/****************************************************************
 *        Copyright   2005 A. Farina All Rights Reserved       *
 ****************************************************************/

#include <windows.h>
#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <time.h>
#include "resource.h"
#include "commctrl.h"
#include "commdlg.h"
#include "Strength.h"
#include "xfmspdll.c"

long longfromstring(char **cursor)
{   long l=0;
	while ((**cursor!=',') && (**cursor!=0x00))
	{	l=l*10+(long)(**cursor-'0');
		(*cursor)++;	
	}          
	if (**cursor!=0x00)  // skip over comma
		(*cursor)++;
 	
 	return l;
}


BOOL WINAPI DllMain (HANDLE hModule, DWORD fdwReason, LPVOID lpReserved)
{
   switch (fdwReason)
   {
      case DLL_PROCESS_ATTACH:
         break;
 
      case DLL_THREAD_ATTACH:
         
         break;
 
      case DLL_THREAD_DETACH:
         
         break;
 
      case DLL_PROCESS_DETACH:
         
         break;
   }
 
   return TRUE;   
}

__declspec(dllexport) short FAR PASCAL QueryXfm(XFMQUERY *cq)
{   
	lstrcpy(cq->szName,TRANSFORMNAME);         
	lstrcpy(cq->szCopyright,"Copyright  2010 A.Farina"); 
	cq->wSupports=XFM_MONO16|XFM_MONO32|XFM_STEREO16|XFM_STEREO32;
	cq->dwFlags=XF_TRANSFORM|XF_USESPRESETSAPI|XF_USESGRAPHAPI|XF_MUSTHIGHLIGHT|XF_USES32BITAPI|XF_AUTOOK|XF_SPECTRALEDITOK;
	cq->dwUserDataLength = sizeof(MLS);
	lstrcpy(cq->szStructDef,STRUCTDEFINITION);
	lstrcpy(cq->szPresetDef,PRESETDEFINITION);
	lstrcpy(cq->szToolHelp,"ITU-T P56 / Time History Analysis");
	return XFM_VALIDLIBRARY;
} 


__declspec(dllexport) BOOL FAR PASCAL XfmInit(COOLINFO far *ci)
{	MLS FAR * lpAmp;
	HANDLE hTones;
	hTones=ci->hUserData;         
	lpAmp=(MLS FAR *)GlobalLock(hTones);
	if (!lpAmp) return FALSE;
		
	// Inizializzazione valori di default....
	lpAmp->hWnd=NULL;
	lpAmp->hInst=NULL;
	lpAmp->hDisplayWnd=NULL;
	lpAmp->LFS=120.0;
	lpAmp->RFS=120.0;
	lpAmp->LCal=94.0;
	lpAmp->RCal=94.0;
	lpAmp->CALtype='F';
	lpAmp->FiltType='L';
	lpAmp->FiltType2='L';
	lpAmp->DispType='1';
	lpAmp->RemoveDC=TRUE;

	strcpy(lpAmp->cName,"*.txt");
	strcpy(lpAmp->LastIRDir,"C:\\");

	// ricerca del file AuroKey.txt
{
	char name[256];
	char regkey[256];
	char LF=10;
	long stop;
	HANDLE nFile;
	DWORD i,Pointer;
	
	char pathbuffer[_MAX_PATH];   
	char searchfile[] = "AuroKey.txt";
	char envvar[] = "PATH";   /* Search for file in PATH environment variable: */
	_searchenv( searchfile, envvar, pathbuffer );   
	if ( *pathbuffer == '\0' )
	// Non trovato, cerco quello specifico (ITUP56.txt)
	{
		char searchfile2[] = "ITUP56.txt";
		char envvar2[] = "PATH";
		_searchenv( searchfile2, envvar2, pathbuffer );   
	}
	if( *pathbuffer != '\0' )
	{
        nFile=CreateFile(pathbuffer, 
		GENERIC_READ, 0,
		NULL,	// pointer to security descriptor 
		OPEN_EXISTING ,	// how to create 
		FILE_ATTRIBUTE_NORMAL,	// file attributes 
		0 	// handle to file with attributes to copy  
		);
		// Lettura Name
		i=0;
		stop=0;
		while (!stop)
		{
			ReadFile(nFile,	// handle of file to read 
			&name[i],	// address of buffer that receives data  
			(1L),	// number of bytes to read 
			&Pointer,	// address of number of bytes read 
			NULL);	// address of structure for data 
			if (name[i]==LF) stop=-1;
			i=i+1;
		}
		name[i-1]=0;
		name[i-2]=0;
		strcpy(lpAmp->username,name);

		// Lettura regkey
		i=0;
		stop=0;
		while (!stop)
		{
			ReadFile(nFile,	// handle of file to read 
			&regkey[i],	// address of buffer that receives data  
			(1L),	// number of bytes to read 
			&Pointer,	// address of number of bytes read 
			NULL);	// address of structure for data 
			if (regkey[i]==LF) stop=-1;
			i=i+1;
		}
		regkey[i-1]=0;
		regkey[i-2]=0;
		strcpy(lpAmp->regkey,regkey);
		// Lettura regkey2
		i=0;
		stop=0;
		while (!stop)
		{
			long OK=-1;
			OK=ReadFile(nFile,	// handle of file to read 
			&regkey[i],	// address of buffer that receives data  
			(1L),	// number of bytes to read 
			&Pointer,	// address of number of bytes read 
			NULL);	// address of structure for data 
			if (regkey[i]==LF) stop=-1;
			if (OK==0) stop=-1;
			i=i+1;
		}
		regkey[i-1]=0;
		regkey[i-2]=0;
		strcpy(lpAmp->regkey,regkey);
	CloseHandle(nFile);
	}
}
// fine lettura da file

	GlobalUnlock(hTones);
	return TRUE;
}

__declspec(dllexport) BOOL FAR PASCAL XfmDestroy(COOLINFO far *ci)
{   MLS FAR * lpAmp;
	HANDLE hTones;
	hTones=ci->hUserData;         
	lpAmp=(MLS FAR *)GlobalLock(hTones);
	if (!lpAmp)
		return FALSE;                       
		
 	// Do your de-initialization here
 	                

 	GlobalUnlock(hTones);
	return TRUE;
}


double dB(double a)
{             
	double db;
	double zero=0.0;

	if(a > zero) db=10.0 * log10(a); //10.0
	else db=-200.0; // valore minimo assumibile, in dB, da un float
	
	return (db);
}
                                                      

void IIR(float  *fIRFilt,long IRL,double Alfa,double Beta,double Gamma,double Mu,double Sigma)
{
	// Filtraggio IIR a 2 poli (Bi-Quad), il risultato sovrascrive il vettore di ingresso
	long n=0;
	double Xn;
	double Xnm1=0.0;
	double Xnm2=0.0;
	double Ynm1=0.0;
	double Ynm2=0.0;

	Xn = fIRFilt[n];
	// X(n) = 2 * (Alfa * (Xn + Mu * Xnm1 + Sigma * Xnm2) + Gamma * Ynm1 - Beta * Ynm2) - Basic
	fIRFilt[n]=(float)(2.0*(Alfa*(Xn+Mu*Xnm1+Sigma*Xnm2)+Gamma*Ynm1-Beta*Ynm2));
	Xnm2 = Xnm1;
	Xnm1 = Xn;

	n=1;
	Xn = fIRFilt[n];
	Ynm1=fIRFilt[n-1];
	fIRFilt[n]=(float)(2.0*(Alfa*(Xn+Mu*Xnm1+Sigma*Xnm2)+Gamma*Ynm1-Beta*Ynm2));
	Xnm2 = Xnm1;
	Xnm1 = Xn;
	
	for(n=2;n<IRL;n++)
	{
		Xn = fIRFilt[n];
		Ynm1 = fIRFilt[n-1];
		Ynm2 = fIRFilt[n-2];
		fIRFilt[n]=(float)(2.0*(Alfa*(Xn+Mu*Xnm1+Sigma*Xnm2)+Gamma*Ynm1-Beta*Ynm2));
		Xnm2 = Xnm1;
		Xnm1 = Xn;
	}
}

void Gain(float dBgain, float  *X,long IRL)
{
	long k;
	float A=(float)pow(10.0,dBgain/20);
	for (k=1; k<IRL;k++) X[k]*=A;
}

void AccFilter(float  *X,float fSamp,long IRL)
{   
	// Ponderazione Accelerazione Asse Generico secondo norma ISO-8041
	
	double PI=3.141592653589793;
	
// filtro 1 - passa alto 0.7943 Hz
	double coef1 =  1.0 - exp(-2.0 * PI * (0.7943) / fSamp);
	double coef1m = 1.0 - coef1;
// filtro 2 - passa alto 0.7943 Hz
	double coef2 =  1.0 - exp(-2.0 * PI * (0.7943) / fSamp);
	double coef2m = 1.0 - coef2;
// filtro 3 - passa basso 5.684 Hz
	double coef3 =  1.0 - exp(-2.0 * PI * (5.684) / fSamp);
	double coef3m = 1.0 - coef3;
// filtro 4 - passa basso 100 Hz
	double coef4 =  1.0 - exp(-2.0 * PI * (100.0) / fSamp);
	double coef4m = 1.0 - coef4;
// filtro 5 - passa basso 100 Hz
	double coef5 =  1.0 - exp(-2.0 * PI * (100.0) / fSamp);
	double coef5m = 1.0 - coef5;

	long k;
	double ritardo1=0.0,ritardo2=0.0;
	double A,B,C=0.0,D=0.0,E=0.0;

	for (k=0; k<IRL;k++)
	{
//		primi 2 filtri passa alto in cascata
		A = X[k] - ritardo1;
		ritardo1 = X[k] * coef1 + ritardo1 * coef1m;
		B = A - ritardo2;
		ritardo2 = A * coef2 + ritardo2 * coef2m;

//		3 filtri passa basso conclusivi
		C = B * coef3 + C * coef3m;
		D = C * coef4 + D * coef4m;
		E = D * coef5 + E * coef5m;
		X[k]=(float)(E*1.19); // correzione per rendere il guadagno ad 1 Hz = 0 dB
	}
}


void AFilter(float  *X,float fSamp,long IRL)
{   
	// Ponderazione "A" secondo norma IEC
	// filtro IIR a 2 poli
	double PI=3.141592653589793;
//  filtro 1 - passa alto 20.6 Hz
	double coef1 =  1.0 - exp(-2.0 * PI * (20.6) / fSamp);
	double coef1m = 1.0 - coef1;
//  filtro 2 - passa alto 20.6 Hz
	double coef2 =  1.0 - exp(-2.0 * PI * (20.6) / fSamp);
	double coef2m = 1.0 - coef2;
//  filtro 3 - passa alto 107.7 Hz
	double coef3 =  1.0 - exp(-2.0 * PI * (107.7) / fSamp);
	double coef3m = 1.0 - coef3;
//  filtro 4 - passa.0 alto 737.9 Hz
	double coef4 =  1.0 - exp(-2.0 * PI * (737.9) / fSamp);
	double coef4m = 1.0 - coef4;
//  filtro 5 - passa basso 12200 Hz
	double coef5 =  1.0 - exp(-2.0 * PI * (12200.0) / fSamp);
	double coef5m = 1.0 - coef5;
//  filtro 6 - passa basso 12200 Hz
	double coef6 =  1.0 - exp(-2.0 * PI * (12200.0) / fSamp);
	double coef6m = 1.0 - coef6;
	long k;
	double ritardo1=0.0,ritardo2=0.0,ritardo3=0.0,ritardo4=0.0;
	double A,B,C,D,E=0.0,F=0.0;

	for (k=0; k<IRL;k++)
	{
//		primi 4 filtri passa alto in cascata
		A = X[k] - ritardo1;
		ritardo1 = X[k] * coef1 + ritardo1 * coef1m;
		B = A - ritardo2;
		ritardo2 = A * coef2 + ritardo2 * coef2m;
		C = B - ritardo3;
		ritardo3 = B * coef3 + ritardo3 * coef3m;
		D = C - ritardo4;
		ritardo4 = C * coef4 + ritardo4 * coef4m;

//		2 filtri passa basso conclusivi
		E = D * coef5 + E * coef5m;
		F = E * coef6 + F * coef6m;
		X[k]=(float)(F/0.858); // correzione per rendere il guadagno ad 1kHz = 0 dB
	}
}


void BandFilter(float f0,float fQ,float  *fIRFilt,float fSamp,long IRL)
{   
	// filtro IIR a 2 poli, BandPass
	double PI=3.141592653589793;
	double Teta0 = 2.0 * PI * f0 / fSamp;
    double d = 2.0 * tan(Teta0 / 2.0 / fQ) / sin(Teta0);
	double Beta = 1.0/2.0*(1.0-0.5*d*sin(Teta0))/(1.0+0.5*d*sin(Teta0));
	double Gamma = (1.0 / 2.0 + Beta) * cos(Teta0);
//  BP
	double Mu = 0.0;
	double Alfa = (1.0/2.0-Beta)/2.0;
	double Sigma = -1.0;

	IIR(fIRFilt,IRL,Alfa,Beta,Gamma,Mu,Sigma);
}

void LPFilter(float f0,float fQ,float  *fIRFilt,float fSamp,long IRL)
{   
	// filtro IIR a 2 poli, LowPass
	double PI=3.141592653589793;
	double Teta0 = 2.0 * PI * f0 / fSamp;
    double d = 2.0 * tan(Teta0 / 2.0 / fQ) / sin(Teta0);
	double Beta = 1.0/2.0*(1.0-0.5*d*sin(Teta0))/(1.0+0.5*d*sin(Teta0));
	double Gamma = (1.0 / 2.0 + Beta) * cos(Teta0);
//  LP
	double Mu = 2.0;
	double Alfa = (0.5+Beta-Gamma)/4.0;
	double Sigma = 1.0;

	IIR(fIRFilt,IRL,Alfa,Beta,Gamma,Mu,Sigma);
}

void HPFilter(float f0,float fQ,float  *fIRFilt,float fSamp,long IRL)
{   
	// filtro IIR a 2 poli, HighPass
	double PI=3.141592653589793;
	double Teta0 = 2.0 * PI * f0 / fSamp;
    double d = 2.0 * tan(Teta0 / 2.0 / fQ) / sin(Teta0);
	double Beta = 1.0/2.0*(1.0-0.5*d*sin(Teta0))/(1.0+0.5*d*sin(Teta0));
	double Gamma = (1.0 / 2.0 + Beta) * cos(Teta0);
//  HP
	double Mu = -2.0;
	double Alfa = (0.5+Beta+Gamma)/4.0;
	double Sigma = 1.0;

	IIR(fIRFilt,IRL,Alfa,Beta,Gamma,Mu,Sigma);
}

void NotchFilter(float f0,float fQ,float  *fIRFilt,float fSamp,long IRL)
{   
	// filtro IIR a 2 poli, Notch
	double PI=3.141592653589793;
	double Teta0 = 2.0 * PI * f0 / fSamp;
    double d = 2.0 * tan(Teta0 / 2.0 / fQ) / sin(Teta0);
	double Beta = 1.0/2.0*(1.0-0.5*d*sin(Teta0))/(1.0+0.5*d*sin(Teta0));
	double Gamma = (1.0 / 2.0 + Beta) * cos(Teta0);
//  BR
	double Mu = -2 * cos(Teta0);
	double Alfa = (0.5+Beta)/2.0;
	double Sigma = 1.0;

	IIR(fIRFilt,IRL,Alfa,Beta,Gamma,Mu,Sigma);
}

void LFilter(float  *X,float fSamp,long IRL)
{   
	//filtro lineare con rimozione rumore sotto i 20 Hz (High Pass 6 poli)
	float f0,fQ; 
//  filtro 1 - passa alto 10 Hz
		f0=10.0f; // Hz
		fQ=0.707f;
		HPFilter(f0,fQ,X,fSamp,IRL);	
//  filtro 2 - passa alto 14 Hz
		f0=14.0f; // Hz
		fQ=0.707f;
		HPFilter(f0,fQ,X,fSamp,IRL);	
//  filtro 3 - passa alto 20 Hz
		f0=20.0f; // Hz
		fQ=0.707f;
		HPFilter(f0,fQ,X,fSamp,IRL);	
}

void IntegFilter(float  *X,long IRL)
{   
	//filtro integratore semplice
	long k;
	for (k=1; k<IRL;k++)
	{
		X[k]+=X[k-1];
	}
}


void BPFilter(float  *X,float fSamp,long IRL)
{   
	// Filtro passa-banda secondo ITU-P56 (160-5500 Hz)
	float f0,fQ; 
//  filtro 1 - passa alto 110 Hz
		f0=110.0f; // Hz
		fQ=0.7f; // Butterworth
		HPFilter(f0,fQ,X,fSamp,IRL);	
//  filtro 2 - passa alto 90 Hz
		f0=90.0f; // Hz
		fQ=1.5f;
		HPFilter(f0,fQ,X,fSamp,IRL);	
//  filtro 3 - passa basso 6500 Hz
		f0=6500.0f; // Hz
		fQ=0.8f;
		LPFilter(f0,fQ,X,fSamp,IRL);	
//  filtro 4 - passa basso 7500 Hz
		f0=7500.0f; // Hz
		fQ=1.8f;     //era 1.9
		LPFilter(f0,fQ,X,fSamp,IRL);	
//  filtro 5 - passa banda 1100 Hz
		f0=1100.0f; // Hz
		fQ=0.11f;
		BandFilter(f0,fQ,X,fSamp,IRL);
// Correzione guadagno -0.11 dB
		Gain(-0.15f,X,IRL);
}

void Lp250Filter(float  *X,float fSamp,long IRL)
{   
	// Filtro passa-banda secondo ITU-P56 (160-5500 Hz)
	float f0,fQ; 
//  filtro 1 - passa basso 250 Hz
		f0=320.0f; // Hz
		fQ=1.0f; // Butterworth
		LPFilter(f0,fQ,X,fSamp,IRL);	
//  filtro 2 - passa basso 260 Hz
		f0=360.0f; // Hz
		fQ=0.6f; // Butterworth
		LPFilter(f0,fQ,X,fSamp,IRL);	
//  filtro 3 - passa basso 270 Hz
		f0=400.0f; // Hz
		fQ=1.1f; // Butterworth
		LPFilter(f0,fQ,X,fSamp,IRL);	
//  filtro 4 - passa basso 280 Hz
		f0=500.0f; // Hz
		fQ=0.5f; // Butterworth
		LPFilter(f0,fQ,X,fSamp,IRL);	
// Correzione guadagno 0.0 dB
		Gain(0.0f,X,IRL);
}

void Vel1Filter(float  *X,float fSamp,long IRL)
{   
	// Filtro Integratore piu' HP ad 1 Hz
	float f0,fQ;
	float G;
//  filtro integratore
	    IntegFilter(X,IRL);
//  filtro 1 - passa alto 1 Hz
		f0=1.0f; // Hz
		fQ=1.0f; // Butterworth
		HPFilter(f0,fQ,X,fSamp,IRL);	
// Correzione guadagno in funzione di Fsamp in modo da mantenerlo invariato a 159.15 Hz
		G=(float)(-33.6-20.0*log(fSamp/48000.0)/log(10.0));
		Gain(G,X,IRL);
}


char CalculateAcoustics(float  *fIRFilt,MLS *lpAmp,char Chan, char FiltType,
						float  *BufPeak,float  *BufInst,float  *Buf30ms,float  *BufFast,float  *BufSlow,float  *BufImp,
						COOLINFO *ci)                                        
{
	long IRL=ci->dwHiSample-ci->dwLoSample+1; // lunghezza segnale da analizzare
	long i;
	float fSamp=(float)ci->lSamprate;   // parametri utili al filtraggio in bande
	char ok=TRUE;
	double mean=0.0;
		
	// creo il progress meter
	ProgressCreate(ci,"Pre-Filtering...",NULL);

	// aggiorno il progress meter
	ProgressMeter(ci,0,2);

	// sottraggo il valore medio (demean), che non fa mai male...
	if (lpAmp->RemoveDC)
	{
		mean=0.0;
		for(i=0;i<IRL;i++) 	mean+=fIRFilt[i];
		mean=mean/(double)IRL;
		for(i=0;i<IRL;i++) 	fIRFilt[i]-=(float)mean;
    }

	// aggiorno il progress meter
	ProgressMeter(ci,1,2);
	if (*ci->lpProgressCanceled) ok=FALSE;
		
	if (FiltType=='L')
	{
		// Applico la ponderazione "Lin"
		// LFilter(fIRFilt,fSamp,IRL);	
	}

	if (FiltType=='A')
	{
		// Applico la ponderazione "A"
		AFilter(fIRFilt,fSamp,IRL);	
	}

	if (FiltType=='B')
	{
		// Applico la ITU "BandPass"
		BPFilter(fIRFilt,fSamp,IRL);	
	}

	if (FiltType=='W')
	{
		// Applico la ISO Acceleraz. asse generico
		AccFilter(fIRFilt,fSamp,IRL);	
	}

	if (FiltType=='V')
	{
		// Applico il passa-basso a 250 Hz - UNI 9916
		Lp250Filter(fIRFilt,fSamp,IRL);	
	}

	if (FiltType=='E')
	{
		// Applico L'imtegrazione da acc a vel. - UNI 9916
		Vel1Filter(fIRFilt,fSamp,IRL);	
	}
	
	
	// aggiorno il progress meter
	ProgressMeter(ci,2,2);
	if (*ci->lpProgressCanceled) ok=FALSE;

	// distruggo il progress meter, ho finito il prefiltraggio!
    ProgressDestroy(ci);          

	if (ok)
	{
		// creo il progress meter
		switch (Chan)
		{
			case 'm':
				ProgressCreate(ci,"Calculating Levels...",NULL);
				break;
			case 'l':
				ProgressCreate(ci,"Calculating Left Channel Levels...",NULL);
				break;
			case 'r':
				ProgressCreate(ci,"Calculating Right Channel Levels...",NULL);
				break;
		}        

		// Blocco di calcolo
		{
			long Npstep=(long)(fSamp/1000.0);   // N. di campioni che fanno circa 1ms
			long Nstep=IRL/Npstep;              // Numero di step
			double Dtau =Npstep/fSamp;          // Lunghezza esatta di uno step, in s
			double Dt   =1.0/fSamp;             // Sampling Interval in s
			long step=0;
			long n;
			double Max=0.0,xi,x2,Leq=0.0;
			double sum=0.0,sumtot=0.0,LocMax=0.0;
			double runFast=0.0,runSlow=0.0,runImp=0.0,run35ms=0.0;
			double maxFast=0.0,maxSlow=0.0,maxImp=0.0,max1ms=0.0;
			long iFast=0;
			double Afast=exp(-Dtau/2.0/0.125)*Dtau/0.125;	// Fattore A per Fast = 0.125 s
			double Aslow=exp(-Dtau/2.0/1.0)*Dtau/1.0;		// Fattore A per Slow = 1 s
			double A1imp=exp(-Dtau/2.0/0.035)*Dtau/0.035;	// Fattore A per Impulse crescente   (35 ms)
			double A2imp=exp(-Dtau/2.0/1.5)*Dtau/1.5;		// Fattore A per Impulse decrescente (1.5 s)
			double T=0.03;									// cost. tempo ITU P56 = 30 ms
			double Ag=exp(-Dt/T);
			double Bfast=1.0-Afast;
			double Bslow=1.0-Aslow;
			double B1imp=1.0-A1imp;
			double B2imp=1.0-A2imp;
			double Bg=1.0-Ag;
			double Afin=0.0,Jfin,Deltaj,Deltajm1;
			double Aj,Cj;
			double pi=0.0,qi=0.0;
			double H=0.2;
			double SpeechLen=0.0,Back,SOL,SNR;
			double THR, Enoise;
			long   I=(long)(H/Dtau); //hangover time in samples, rounded
			double c[30]; //soglie di livello
			long   a[30]; //numero di campioni oltre la soglia
			long   h[30]; //memoria dall'ultimo campione sopra soglia
			long j,Nnoise,hh;
			double M=15.9; //Threshold standard secondo ITU P56
			//double M=4.9; //Valore modificato
			BOOL   ImpFlag=FALSE;
			float  Dur=0.0f;
			double sqrt2=sqrt(2.0);
			// char textbuf[40];

			// preparazione vettori per ITU P56
			c[0]=1.0/sqrt2;
			a[0]=0;
			h[0]=I;
			for(j=1;j<30;j++)    //scendo a passi di circa 3 dB
			{
				c[j]=c[j-1]/sqrt2;
				a[j]=0;
				h[j]=I;
			}


			if ((Nstep*Npstep)>IRL) Nstep-=1;
    		// MessageBox(NULL,_ltoa(Nstep,textbuf,10),"Number of steps",MB_ICONSTOP|MB_OK);

			// inizializzo a zero il progress meter
			ProgressMeter(ci,0,Nstep);

			for(step=0;step<Nstep;step++)       // inizio il ciclo con step 1ms, parto da 0
			{
				sum=0.0;
				LocMax=0.0;
				for(n=0;n<Npstep;n++)  //ciclo interno sul blocchetto di 1ms
				{
					xi=fIRFilt[n+step*Npstep];	// campione corrente
					x2=xi*xi;					// campione al quadrato
					sum+=x2;					// somma dei quadrati
					if (x2>Max) Max=x2;			// ricerca del Max peak istantaneo
					if (x2>LocMax) LocMax=x2;	// ricerca del Max peak istantaneo locale
					pi=Ag*pi+Bg*fabs(xi);		// valore intermedio
					qi=Ag*qi+Bg*fabs(pi);		// Envelope secondo ITU P56
				}
				sum/=Npstep;	  // Valore short-Leq di 1ms
				sumtot+=sum;      // Accumulo il totale generale per l'Leq

				// Ciclo ricerca threshold ITU P56
				for(j=1;j<30;j++) 
				{
					if (qi>=c[j]) {a[j]+=1;h[j]=0;}
					if (qi<c[j])
					{
						if (h[j]<I) {a[j]+=1;h[j]+=1;}
					}
				}
				// a[j]  ora uguale al numero di campioni sopra il threshold j-esimo

				runFast=Afast*sum+Bfast*runFast;
				runSlow=Aslow*sum+Bslow*runSlow;

	// Costante di tempo Impulse

				// Nuova versione
				run35ms=A1imp*sum+B1imp*run35ms;       // questo  l'RMS 35ms corrente
				if (run35ms>runImp)
					runImp=run35ms;
				else
					runImp*=B2imp;

				// memorizzo i valori max Fast, Slow, Impulse
				if (runFast>maxFast) { maxFast=runFast; iFast = step;}
				if (runSlow>maxSlow) maxSlow=runSlow;
				if (runImp>maxImp) maxImp=runImp;
				if (sum>max1ms) max1ms=sum;

				// Aggiungo ai 6 buffers i valori RMS correnti, gi in dB
				BufInst[step]=(float)dB(sum);		   // memorizzo per il grafico il valore istantaneo
				Buf30ms[step]=(float)dB(qi*qi);		   // memorizzo per il grafico il valore Envelope ITU
				BufFast[step]=(float)dB(runFast);      // memorizzo per il grafico il Fast corrente
				BufSlow[step]=(float)dB(runSlow);      // memorizzo per il grafico il Slow corrente
				BufImp[step]=(float)dB(runImp);        // memorizzo per il grafico il Imp  corrente
				BufPeak[step]=(float)dB(LocMax);       // memorizzo per il grafico il Peak  corrente
				// aggiorno il progress meter
				ProgressMeter(ci,step,Nstep);
				if (*ci->lpProgressCanceled) {ok=FALSE;break;}
			}		// fine del ciclo esterno con step 1ms

			if (ok)
			{
				// Converto tutti i risultati in dB
				Max=dB(Max);
				maxFast=dB(maxFast);
				maxSlow=dB(maxSlow);
				maxImp=dB(maxImp);
				max1ms=dB(max1ms);
				Leq=dB(sumtot/Nstep); // divido per il n. di blocchetti, ed ho l'energia media

				// Verifica componente impulsiva
				// Prima condizione: Lmax,imp - Lmax,slow >= 6 dB
				if ((maxImp-maxSlow)>=6.0)
				{	// Seconda condizione: Dur < 1s
					long Dur1=0,Dur2=0;
					for(step=iFast;step>0;step--)          // inizio il ciclo con step 1ms
					if (BufFast[step]<(maxFast-10.0)) break;
					if (BufFast[step]<(maxFast-10.0)) Dur1=step;
					for(step=iFast;step<Nstep;step++)          // inizio il ciclo con step 1ms
					if (BufFast[step]<(maxFast-10.0)) break;
					if (BufFast[step]<(maxFast-10.0)) Dur2=step;
					if ((Dur1>0)&&(Dur2>0)) Dur=(float)(Dtau*(Dur2-Dur1-1));
					if (Dur<1.0) ImpFlag=TRUE;
				}

				// Calcolo Active Speech level
				Deltajm1=50.0;  //tutta l'energia impaccata in un unico campione
				for(j=29;j>0;j--)          // inizio il ciclo sui 30 possibili valori di Threshold
				{
					if (a[j]==0) a[j]=1;
					Aj=10.0*log10(sumtot/a[j]);
					Cj=20.0*log10(c[j]);
					Deltaj = Aj-Cj;
					if (Deltaj<=M)
					{
						Jfin=(double)(j+(M-Deltaj)/(Deltajm1-Deltaj));
						Afin=dB(sumtot/a[j])+(Jfin-j)*(dB(sumtot/a[j+1])-dB(sumtot/a[j]));
						SpeechLen=((double)a[j])/Nstep; // frazione dei campioni sopra il threshold rispetto al n. campioni totali
						break; // ho trovato la soluzione, esco dal ciclo.
					}
					Deltajm1=Deltaj;
				}

				THR=Afin-M; // Threshold
				// Ora calcolo il Background Noise
				Enoise=0.0;
				Nnoise=0;hh=0;
				for(step=0;step<Nstep;step++)       // inizio il ciclo con step 1ms, parto da 0
				{
					if (Buf30ms[step]>=THR) hh=0; // sono nel parlato, do inizio alla coda
					if (Buf30ms[step]<THR)
						if (hh<I) hh+=1; // sto ancora avanzando nella coda di un pezzo di parlato
					else
					{
						// sono finalmente nel rumore di fondo
						Nnoise +=1;
						Enoise +=(double)(pow(10,Buf30ms[step]/10.0));
					}
				}
				Back=dB(Enoise/Nnoise);
				SOL=dB(pow(10,Afin/10.0)-pow(10,Back/10.0)); // tolgo il background noise
				SNR=SOL-Back; // Speech to Noise Ratio
				
				// Salvataggio Risultati

				if (Chan=='r')
				{
					// Right
					lpAmp->RLeq=(float)(Leq+lpAmp->RFS);
					if (lpAmp->CALtype=='L') // forzo in calibrazione il valore di Leq
					{
						lpAmp->RFS+=lpAmp->RCal-lpAmp->RLeq;
						lpAmp->RLeq=lpAmp->RCal;
					}
					lpAmp->RMaxPeak=(float)(Max+lpAmp->RFS);
					lpAmp->RMaxFast=(float)(maxFast+lpAmp->RFS);
					lpAmp->RMaxSlow=(float)(maxSlow+lpAmp->RFS);
					lpAmp->RMaxImp =(float)(maxImp +lpAmp->RFS);
					lpAmp->RMax1ms =(float)(max1ms +lpAmp->RFS);
					lpAmp->RImpFlag=ImpFlag;
					lpAmp->RDur=(float)Dur;
					lpAmp->RASL=(float)(Afin+lpAmp->RFS);	// Active Speech Level
					lpAmp->RTHR=(float)(THR+lpAmp->RFS);	// Threshold
					lpAmp->RAR=(float)pow(10,(Leq-Afin)/10);// Activity Ratio // old
//new				lpAmp->RAR=(float)(SpeechLen);// Frazione dei campioni con speech attiva rispetto al totale
					lpAmp->RBACK=(float)(Back+lpAmp->RFS);
					lpAmp->RSNR=(float)(SNR);
				}
				else
				{
					// Left
					lpAmp->LLeq=(float)(Leq+lpAmp->LFS);
					if (lpAmp->CALtype=='L') // forzo in calibrazione il valore di Leq
					{
						lpAmp->LFS+=lpAmp->LCal-lpAmp->LLeq;
						lpAmp->LLeq=lpAmp->LCal;
					}
					lpAmp->LMaxPeak=(float)(Max+lpAmp->LFS);
					lpAmp->LMaxFast=(float)(maxFast+lpAmp->LFS);
					lpAmp->LMaxSlow=(float)(maxSlow+lpAmp->LFS);
					lpAmp->LMaxImp =(float)(maxImp +lpAmp->LFS);
					lpAmp->LMax1ms =(float)(max1ms +lpAmp->LFS);
					lpAmp->LImpFlag=ImpFlag;
					lpAmp->LDur=(float)Dur;
					lpAmp->LASL=(float)(Afin+lpAmp->LFS);	// Active Speech Level
					lpAmp->LTHR=(float)(THR+lpAmp->LFS);	// Threshold
					lpAmp->LAR=(float)pow(10,(Leq-Afin)/10);// Activity Ratio // old
// new				lpAmp->LAR=(float)(SpeechLen);// Frazione dei campioni con speech attiva rispetto al totale
					lpAmp->LBACK=(float)(Back+lpAmp->LFS);
					lpAmp->LSNR=(float)(SNR);
				}
			} // if ok interno
		} 


		// distruggo il progress meter, ho finito!
		ProgressDestroy(ci);          
	} // if ok esterno

    // ritorno ok
    return (ok);
}

__declspec(dllexport) BOOL FAR PASCAL XfmSetup(HWND hWnd, HINSTANCE hInst, COOLINFO far *ci)
{	short nRc;
	FARPROC lpfnDIALOGMsgProc; 

	lpfnDIALOGMsgProc = GetProcAddress(hInst,(LPCSTR)MAKELONG(100,0));
	
	nRc = DialogBoxParam((HINSTANCE)hInst,(LPCSTR)MAKEINTRESOURCE(IDD_TRANSFORM), (HWND)hWnd, (DLGPROC)lpfnDIALOGMsgProc,(DWORD)ci);
	                 
	if (nRc)
	{
	    // se devo proseguire inizializzo i campi hWnd e hInst di ci->hUserData
	    // per la procedura XfmDo
    	MLS FAR * lpAmp;
		HANDLE hCotype;  
							
		hCotype=ci->hUserData;         
		lpAmp=(MLS FAR *)GlobalLock(hCotype);
		if (!lpAmp) nRc=FALSE;
		else
		{	
			lpAmp->hWnd=hWnd;
			lpAmp->hInst=hInst;                                            
			GlobalUnlock(hCotype);
	    }
		// MessageBox(hWnd,"XFMInit was started - TRUE",(*ci).cq->szName,MB_ICONSTOP|MB_OK);
		// chiamo manualmente la XFMDO
		// nRc=XfmDo(ci);
    }
// else
// MessageBox(hWnd,"XFMInit was started - FALSE",(*ci).cq->szName,MB_ICONSTOP|MB_OK);
    
	return nRc;
}


//-----------------------------------------------------------------------------------
// Invia un messaggio WM_PAINT alla finestra che gestisce il display
//-----------------------------------------------------------------------------------
void UpdateDisplay(HWND hDisplayWnd)
{

	InvalidateRect(hDisplayWnd, NULL, TRUE);
	UpdateWindow(hDisplayWnd);

}


#pragma optimize("", off)
void RussianRoulette(void)
	{
        long i,zero,rn;
        srand( (long)(time( NULL )*1000) );
        rn=rand();
		if (rn> (3 * RAND_MAX / 4))
		{
			// Roulette russa fallita
        	MessageBox(NULL,"Hey!\n\nYour AURORA software is not properly registered!\nSorry, but now CoolEdit will crash...","Russian Roulette failed",MB_ICONSTOP|MB_OK);
			zero=0;
			i=1/zero;
		}
	}
#pragma optimize("", on)

__declspec(dllexport) BOOL FAR PASCAL XfmDo(COOLINFO *ci)
{	
	MLS FAR * lpAmp = NULL;
	HANDLE hTones = NULL;
	long i;
    HANDLE hIR,hIRFilt;
	HANDLE hLeftBufInst,hLeftBuf30ms,hLeftBufFast,hLeftBufSlow,hLeftBufImp,hLeftBufPeak;
	HANDLE hRightBufInst,hRightBuf30ms,hRightBufFast,hRightBufSlow,hRightBufImp,hRightBufPeak;
    float  *fIR=NULL;     // IR originale
    float  *fIRFilt=NULL; // IR filtrata e buffer interi
	float  *LeftBufInst;   //Buffer 1ms  Left
	float  *LeftBuf30ms;   //Buffer 1ms  Left
	float  *LeftBufFast;   //Buffer Fast Left
	float  *LeftBufSlow;   //Buffer Slow Left
	float  *LeftBufImp;    //Buffer Imp  Left
	float  *LeftBufPeak;   //Buffer Peak  Left
	float  *RightBufInst;   //Buffer 1ms  Right
	float  *RightBuf30ms;   //Buffer 1ms  Right
	float  *RightBufFast;   //Buffer Fast Right
	float  *RightBufSlow;   //Buffer Slow Right
	float  *RightBufImp;    //Buffer Imp  Right
	float  *RightBufPeak;   //Buffer Imp  Right
    char   *cdata;
    short  *intbuf;         // buffer dati imp. res. da Cool Edit
    long IRL=ci->dwHiSample-ci->dwLoSample+1; // lunghezza imp. res. in campioni
    long Npstep=(long)(ci->lSamprate/1000.0);   // N. di campioni che fanno circa 1ms
	long Nstep=IRL/Npstep;                      // Numero di step
    char CantAllocLevel;
    char Stereo=(ci->wChannels==2);
    char Channels=(char) ci->wChannels;
    char Chan; // 'm' mono, 'l' left, 'r' right, serve per il progress meter
	HWND hWnd;
	HINSTANCE hInst;	
	char ok=1; 
	WORD wFlags;
	DWORD NbytesBuf;
	// char textbuf[40];
	// double RFact=1.0/32768.0;   

//  Variabili per controllo registrazione
	char Username[256];
	char tmpstr[16];
    long Regkey,key,key2,seed,seed2;
    
    // inizializzo le variabili usate
    hTones=ci->hUserData;         
	if (!(lpAmp=(MLS FAR *)GlobalLock(hTones))) return 1; 
	hWnd=lpAmp->hWnd;
	hInst=lpAmp->hInst;
	
	// MessageBox(hWnd,"XFMDo was started",(*ci).cq->szName,MB_ICONSTOP|MB_OK);

//  Verifica registration Key
	seed=734+19*1; //ITUP56  il modulo Aurora n. 19
	seed2=717;
	strcpy(Username,lpAmp->username);
	Regkey=atol(lpAmp->regkey);
	key=0;
	for (i=0;i<(long)strlen(Username);i++)
	{
		strncpy(tmpstr,Username + i,1);
		key=key + (i+1) * (short)tmpstr[0] ;
	}
    key2=(key+1) * seed2+121; // Aggiungo 121 al reg.key, questo modulo va solo con una licenza Aurora 4.0
	key=(key+1) * seed;
	if ((key != Regkey) && (key2!=Regkey)) RussianRoulette();
    // fine controllo registrazione
	ProgressCreate(ci,"Initializing...",NULL);
	ProgressMeter(ci,1,3);
	
	// dimensiono il buffer dati per il display
	NbytesBuf=(DWORD)(4*Nstep); //Nstep valori float, 4 bytes cadauno, con Npstep tale da valere circa 1ms
    // alloco memoria                        
	// MessageBox(hWnd,"Pronto ad Allocare",(*ci).cq->szName,MB_ICONSTOP|MB_OK);
	CantAllocLevel=0; // inizializzo CantAllocLevel e provo ad allocare
	// nota che, dato che gli OR vengono valutati da sin. a dx., se 
	// un handle non viene lockato, l'handle successivo non viene allocato.
	// MessageBox(hWnd,_ltoa(NbytesBuf,textbuf,10),"Pronto ad Allocare - NBytesBuf=",MB_ICONSTOP|MB_OK);
	if (!(hIR=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,IRL*4l)))
		CantAllocLevel=1;
	else if (!(fIR=(float  *)GlobalLock(hIR)))                               
		CantAllocLevel=2;
	else if	(!(hIRFilt=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,IRL*4l*Channels))) 
		CantAllocLevel=3;	 
	else if (!(fIRFilt=(float  *)GlobalLock(hIRFilt)))                         
		CantAllocLevel=4;
	else if	(!(hLeftBufInst=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,NbytesBuf))) 
		CantAllocLevel=5;	 
	else if (!(LeftBufInst=(float  *)GlobalLock(hLeftBufInst)))                         
		CantAllocLevel=6;
	else if	(!(hLeftBuf30ms=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,NbytesBuf))) 
		CantAllocLevel=7;	 
	else if (!(LeftBuf30ms=(float  *)GlobalLock(hLeftBuf30ms)))                         
		CantAllocLevel=8;
	else if	(!(hLeftBufFast=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,NbytesBuf))) 
		CantAllocLevel=9;	 
	else if (!(LeftBufFast=(float  *)GlobalLock(hLeftBufFast)))                         
		CantAllocLevel=10;
	else if	(!(hLeftBufSlow=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,NbytesBuf))) 
		CantAllocLevel=11;	 
	else if (!(LeftBufSlow=(float  *)GlobalLock(hLeftBufSlow)))                         
		CantAllocLevel=12;
	else if	(!(hLeftBufImp=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,NbytesBuf))) 
		CantAllocLevel=13;	 
	else if (!(LeftBufImp=(float  *)GlobalLock(hLeftBufImp)))                         
		CantAllocLevel=14;
	else if	(!(hLeftBufPeak=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,NbytesBuf))) 
		CantAllocLevel=15;	 
	else if (!(LeftBufPeak=(float  *)GlobalLock(hLeftBufPeak)))                         
		CantAllocLevel=16;
	if (Channels==2)
	{				// Alloco i buffers per il canale Right)
		if	(!(hRightBufInst=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,NbytesBuf))) 
			CantAllocLevel=17;	 
		else if (!(RightBufInst=(float  *)GlobalLock(hRightBufInst)))                         
			CantAllocLevel=18;
		else if	(!(hRightBuf30ms=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,NbytesBuf))) 
			CantAllocLevel=19;	 
		else if (!(RightBuf30ms=(float  *)GlobalLock(hRightBuf30ms)))                         
			CantAllocLevel=20;
		else if	(!(hRightBufFast=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,NbytesBuf))) 
			CantAllocLevel=21;	 
		else if (!(RightBufFast=(float  *)GlobalLock(hRightBufFast)))                         
			CantAllocLevel=22;
		else if	(!(hRightBufSlow=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,NbytesBuf))) 
			CantAllocLevel=23;	 
		else if (!(RightBufSlow=(float  *)GlobalLock(hRightBufSlow)))                         
			CantAllocLevel=24;
		else if	(!(hRightBufImp=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,NbytesBuf))) 
			CantAllocLevel=25;	 
		else if (!(RightBufImp=(float  *)GlobalLock(hRightBufImp)))                         
			CantAllocLevel=26;
		else if	(!(hRightBufPeak=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,NbytesBuf))) 
			CantAllocLevel=27;	 
		else if (!(RightBufPeak=(float  *)GlobalLock(hRightBufPeak)))                         
			CantAllocLevel=28;
	}
	// MessageBox(hWnd,"Ho Ultimato le richieste di Allocazione",(*ci).cq->szName,MB_ICONSTOP|MB_OK);

	if (CantAllocLevel) // se l'allocazione non  riuscita...
	{                   // libero la parte di memoria allocata
		MessageBox(hWnd,"The system cannot allocate enough memory\nto calculate levels.\n\nRetry after closing some windows or\nwith a shorter waveform.",(*ci).cq->szName,MB_ICONSTOP|MB_OK);
		// unlocko gli oggetti lockati
		if (CantAllocLevel>26) GlobalUnlock(hRightBufImp);
		if (CantAllocLevel>24) GlobalUnlock(hRightBufSlow);
		if (CantAllocLevel>22) GlobalUnlock(hRightBufFast);
		if (CantAllocLevel>20) GlobalUnlock(hRightBuf30ms);
		if (CantAllocLevel>18) GlobalUnlock(hRightBufInst);
		if (CantAllocLevel>16) GlobalUnlock(hLeftBufPeak);
		if (CantAllocLevel>14) GlobalUnlock(hLeftBufImp);
		if (CantAllocLevel>12) GlobalUnlock(hLeftBufSlow);
		if (CantAllocLevel>10) GlobalUnlock(hLeftBufFast);
		if (CantAllocLevel>8) GlobalUnlock(hLeftBuf30ms);
		if (CantAllocLevel>6) GlobalUnlock(hLeftBufInst);
		if (CantAllocLevel>4) GlobalUnlock(hIRFilt);
		if (CantAllocLevel>2) GlobalUnlock(hIR);
        // libero gli oggetti allocati
		if (CantAllocLevel>27) GlobalFree(hRightBufPeak);
		if (CantAllocLevel>25) GlobalFree(hRightBufImp);
		if (CantAllocLevel>23) GlobalFree(hRightBufSlow);
		if (CantAllocLevel>21) GlobalFree(hRightBufFast);
		if (CantAllocLevel>19) GlobalFree(hRightBuf30ms);
		if (CantAllocLevel>17) GlobalFree(hRightBufInst);
		if (CantAllocLevel>15) GlobalFree(hLeftBufPeak);
		if (CantAllocLevel>13) GlobalFree(hLeftBufImp);
		if (CantAllocLevel>11) GlobalFree(hLeftBufSlow);
		if (CantAllocLevel>9) GlobalFree(hLeftBufFast);
		if (CantAllocLevel>7) GlobalFree(hLeftBuf30ms);
		if (CantAllocLevel>5) GlobalFree(hLeftBufInst);
		if (CantAllocLevel>3) GlobalFree(hIRFilt);
		if (CantAllocLevel>1) GlobalFree(hIR);
		GlobalUnlock(hTones);        
		return 1;
	}	
	// MessageBox(hWnd,"Ho Allocato",(*ci).cq->szName,MB_ICONSTOP|MB_OK);
    
    // inizializzo i puntatori ausiliari
    cdata=(char   *)fIRFilt;   // faccio puntare cdata  all'inizio del buffer float
    intbuf=(short *)fIRFilt;   // faccio puntare intbuf all'inizio del buffer float
    
	// leggo i dati da Cool Edit
	ProgressMeter(ci,2,3);
	if (ci->wChannels==2) wFlags=RWEX_32BIT|RWEX_STEREO;
	else wFlags=RWEX_32BIT|RWEX_MONO;
	ReadDataEx(ci,cdata,ci->dwLoSample,IRL,wFlags);    
	ProgressMeter(ci,3,3);
	// distruggo il progress meter, ho finito!
	ProgressDestroy(ci);          
 
	// CALCOLO DEI PARAMETRI ACUSTICI
	if (!(Stereo)) // mono
	{
		// copio i dati da intbuf ad fIR, convertendoli in float
		// e riscalandoli rispetto a 32768 per evitare overflow
		// nelle operazioni successive
		for (i=0;i<IRL;i++) fIR[i]=fIRFilt[i]/32767.0f;
        Chan='m'; // mono
        ok=CalculateAcoustics(fIR,lpAmp,Chan,lpAmp->FiltType,LeftBufPeak,LeftBufInst,LeftBuf30ms,LeftBufFast,LeftBufSlow,LeftBufImp,ci);
		for (i=0;i<IRL;i++) fIRFilt[i]=fIR[i]*32767.0f;
	}	
	else // stereo      
	{   
		DWORD ii=0;
		
		// canale destro
		for (i=0;i<IRL;i++) fIR[i]=fIRFilt[(i<<1)+1]/32767.0f;
        Chan='r'; // right
        ok=CalculateAcoustics(fIR,lpAmp,Chan,lpAmp->FiltType2,RightBufPeak,RightBufInst,RightBuf30ms,RightBufFast,RightBufSlow,RightBufImp,ci);
		for (i=0;i<IRL;i++) fIRFilt[(i<<1)+1]=fIR[i]*32767.0f;
        if (ok)
        {
			// canale sinistro
			for (i=0;i<IRL;i++) fIR[i]=fIRFilt[(i<<1)]/32767.0f;
	        Chan='l'; // left
			ok=CalculateAcoustics(fIR,lpAmp,Chan,lpAmp->FiltType,LeftBufPeak,LeftBufInst,LeftBuf30ms,LeftBufFast,LeftBufSlow,LeftBufImp,ci);
			for (i=0;i<IRL;i++) fIRFilt[(i<<1)]=fIR[i]*32767.0f;
        }
	}			

	// metto in lpAmp i puntatori ai buffers della Time History
	lpAmp->LeftBufPeak=(long)LeftBufPeak;
	lpAmp->LeftBufInst=(long)LeftBufInst;
	lpAmp->LeftBuf30ms=(long)LeftBuf30ms;
	lpAmp->LeftBufFast=(long)LeftBufFast;
	lpAmp->LeftBufSlow=(long)LeftBufSlow;
	lpAmp->LeftBufImp=(long)LeftBufImp;
	lpAmp->RightBufPeak=(long)RightBufPeak;
	lpAmp->RightBufInst=(long)RightBufInst;
	lpAmp->RightBuf30ms=(long)RightBuf30ms;
	lpAmp->RightBufFast=(long)RightBufFast;
	lpAmp->RightBufSlow=(long)RightBufSlow;
	lpAmp->RightBufImp=(long)RightBufImp;
	lpAmp->SampRate=ci->lSamprate;
	lpAmp->N=IRL;
	lpAmp->wChannels=ci->wChannels;

	// unlocko hTones
	GlobalUnlock(hTones);

    // se  andato tutto bene chiamo la Dialog Box di visualizzazione risultati
    if (ok)
    {   
		short nRc;
		FARPROC lpfnDIALOGMsgProc;

		// mando un suono di conferma
		MessageBeep(MB_OK);
		lpfnDIALOGMsgProc = GetProcAddress(hInst,(LPCSTR)MAKELONG(101,0));
		nRc = DialogBoxParam((HINSTANCE)hInst,(LPCSTR)MAKEINTRESOURCE(IDD_FINAL), (HWND)hWnd, (DLGPROC)lpfnDIALOGMsgProc,(DWORD)ci);
	                 
		if (nRc)
		{
			// Esporto il segnale filtrato
			long Lblock;
			long LastBlock;
			if (ci->wChannels==2) wFlags=RWEX_32BIT|RWEX_STEREO;
			else wFlags=RWEX_32BIT|RWEX_MONO;
			Lblock=(long)(IRL/10.0);
			LastBlock=IRL-(9*Lblock);
			ProgressCreate(ci,"Exporting Filtered Signal...",NULL);
			ProgressMeter(ci,2,10);
			WriteDataEx(ci,cdata,ci->dwLoSample,IRL,wFlags);
			// aggiorno il progress meter
			ProgressMeter(ci,10,10);
			// distruggo il progress meter, ho finito!
			ProgressDestroy(ci);          
		}
    }

 // libero la memoria perch adesso fIR e fIRFilt non servono pi
//	MessageBox(hWnd,"Unlock IRFilt","Uscita",MB_ICONSTOP|MB_OK);
    GlobalUnlock(hIRFilt);
//	MessageBox(hWnd,"Free IRFilt","Uscita",MB_ICONSTOP|MB_OK);
    GlobalFree(hIRFilt);
//	MessageBox(hWnd,"Unlock IR","Uscita",MB_ICONSTOP|MB_OK);
    GlobalUnlock(hIR);
//	MessageBox(hWnd,"Free IR","Uscita",MB_ICONSTOP|MB_OK);
    GlobalFree(hIR);

//  Buffers Left
//	MessageBox(hWnd,"Unlock LeftBufInst","Uscita",MB_ICONSTOP|MB_OK);
    GlobalUnlock(hLeftBufInst);
//	MessageBox(hWnd,"Free LeftBufInst","Uscita",MB_ICONSTOP|MB_OK);
    GlobalFree(hLeftBufInst);
//	MessageBox(hWnd,"Unlock LeftBuf30ms","Uscita",MB_ICONSTOP|MB_OK);
    GlobalUnlock(hLeftBuf30ms);
//	MessageBox(hWnd,"Free LeftBuf30ms","Uscita",MB_ICONSTOP|MB_OK);
    GlobalFree(hLeftBuf30ms);
//	MessageBox(hWnd,"Unlock LeftBufFast","Uscita",MB_ICONSTOP|MB_OK);
    GlobalUnlock(hLeftBufFast);
//	MessageBox(hWnd,"Free LeftBufFast","Uscita",MB_ICONSTOP|MB_OK);
    GlobalFree(hLeftBufFast);
//	MessageBox(hWnd,"Unlock LeftBufSlow","Uscita",MB_ICONSTOP|MB_OK);
    GlobalUnlock(hLeftBufSlow);
//	MessageBox(hWnd,"Free LeftBufSlow","Uscita",MB_ICONSTOP|MB_OK);
    GlobalFree(hLeftBufSlow);
//	MessageBox(hWnd,"Unlock LeftBufImp","Uscita",MB_ICONSTOP|MB_OK);
    GlobalUnlock(hLeftBufImp);
//	MessageBox(hWnd,"Free LeftBufImp","Uscita",MB_ICONSTOP|MB_OK);
    GlobalFree(hLeftBufImp);
//	MessageBox(hWnd,"Free LeftBufPeak","Uscita",MB_ICONSTOP|MB_OK);
    GlobalFree(hLeftBufPeak);

	if (ci->wChannels==2)
	{
	//  Buffers Right
	//	MessageBox(hWnd,"Unlock RightBufInst","Uscita",MB_ICONSTOP|MB_OK);
		GlobalUnlock(hRightBufInst);
	//	MessageBox(hWnd,"Free RightBufInst","Uscita",MB_ICONSTOP|MB_OK);
		GlobalFree(hRightBufInst);
	//	MessageBox(hWnd,"Unlock RightBuf30ms","Uscita",MB_ICONSTOP|MB_OK);
		GlobalUnlock(hRightBuf30ms);
	//	MessageBox(hWnd,"Free RightBuf30ms","Uscita",MB_ICONSTOP|MB_OK);
		GlobalFree(hRightBuf30ms);
	//	MessageBox(hWnd,"Unlock RightBufFast","Uscita",MB_ICONSTOP|MB_OK);
		GlobalUnlock(hRightBufFast);
	//	MessageBox(hWnd,"Free RightBufFast","Uscita",MB_ICONSTOP|MB_OK);
		GlobalFree(hRightBufFast);
	//	MessageBox(hWnd,"Unlock RightBufSlow","Uscita",MB_ICONSTOP|MB_OK);
		GlobalUnlock(hRightBufSlow);
	//	MessageBox(hWnd,"Free RightBufSlow","Uscita",MB_ICONSTOP|MB_OK);
		GlobalFree(hRightBufSlow);
	//	MessageBox(hWnd,"Unlock RightBufImp","Uscita",MB_ICONSTOP|MB_OK);
		GlobalUnlock(hRightBufImp);
	//	MessageBox(hWnd,"Free RightBufImp","Uscita",MB_ICONSTOP|MB_OK);
		GlobalFree(hRightBufImp);
	//	MessageBox(hWnd,"Free RightBufPeak","Uscita",MB_ICONSTOP|MB_OK);
		GlobalFree(hRightBufPeak);
	}


//	MessageBox(hWnd,"Return","Uscita",MB_ICONSTOP|MB_OK);
	return (!ok); 
}

void DialogToStruct(COOLINFO *ci, HWND hWndDlg, MLS *lpAmp)
{	
	char textbuf[40];
	float temp;

	// copio il tipo di filtraggio
	lpAmp->FiltType='L';  // Lineare	
	lpAmp->FiltType2='L'; // Lineare	
	if (IsDlgButtonChecked(hWndDlg,IDC_BANDPASS)) lpAmp->FiltType='B' ; 
	if (IsDlgButtonChecked(hWndDlg,IDC_AWEIGHT)) lpAmp->FiltType='A' ; 
	if (IsDlgButtonChecked(hWndDlg,IDC_ACCWEIGHT)) lpAmp->FiltType='W' ; 
	if (IsDlgButtonChecked(hWndDlg,IDC_UNIWEIGHT)) lpAmp->FiltType='V' ; 
	if (IsDlgButtonChecked(hWndDlg,IDC_VELWEIGHT)) lpAmp->FiltType='E' ; 
	if (IsDlgButtonChecked(hWndDlg,IDC_BANDPASS2)) lpAmp->FiltType2='B' ; 
	if (IsDlgButtonChecked(hWndDlg,IDC_AWEIGHT2)) lpAmp->FiltType2='A' ; 
	if (IsDlgButtonChecked(hWndDlg,IDC_ACCWEIGHT2)) lpAmp->FiltType2='W' ; 
	if (IsDlgButtonChecked(hWndDlg,IDC_UNIWEIGHT2)) lpAmp->FiltType2='V' ; 
	if (IsDlgButtonChecked(hWndDlg,IDC_VELWEIGHT2)) lpAmp->FiltType2='E' ; 

	// Remove DC
	lpAmp->RemoveDC=IsDlgButtonChecked(hWndDlg,IDC_REMOVEDC) ; 

	
	// copio il tipo di calibrazione
	lpAmp->CALtype='F';	
	if (IsDlgButtonChecked(hWndDlg,IDC_RADIO_Leq)) lpAmp->CALtype='L' ; 

	// copio il valore in dB del FS
	if (lpAmp->CALtype=='F')
	{
		// Valori di full-scale
		GetDlgItemText(hWndDlg,IDC_LFS,textbuf,39);
		temp=(float)atof(textbuf);
		lpAmp->LFS=temp;
		if (ci->wChannels==2)
		{
			GetDlgItemText(hWndDlg,IDC_RFS,textbuf,39);
			temp=(float)atof(textbuf);
			lpAmp->RFS=temp;
		}
	}
	else
	{
		// Valori di Leq imposto
		GetDlgItemText(hWndDlg,IDC_LFS,textbuf,39);
		temp=(float)atof(textbuf);
		lpAmp->LCal=temp;
		if (ci->wChannels==2)
		{
			GetDlgItemText(hWndDlg,IDC_RFS,textbuf,39);
			temp=(float)atof(textbuf);
			lpAmp->RCal=temp;
		}
	}

    // Registrazione
    GetDlgItemText(hWndDlg,IDC_USERNAME,lpAmp->username,256);
    GetDlgItemText(hWndDlg,IDC_REGKEY,lpAmp->regkey,256);
}


void StructToDialog(COOLINFO FAR *ci, MLS FAR *lpAmp, HWND hWndDlg)
{   
	char textbuf[40];

    // Setto i flag del tipo di filtro
	if (lpAmp->FiltType=='B') CheckDlgButton(hWndDlg,IDC_BANDPASS,1);
	if (lpAmp->FiltType=='A') CheckDlgButton(hWndDlg,IDC_AWEIGHT,1);
	if (lpAmp->FiltType=='W') CheckDlgButton(hWndDlg,IDC_ACCWEIGHT,1);
	if (lpAmp->FiltType=='V') CheckDlgButton(hWndDlg,IDC_UNIWEIGHT,1);
	if (lpAmp->FiltType=='E') CheckDlgButton(hWndDlg,IDC_VELWEIGHT,1);
	if (lpAmp->FiltType2=='B') CheckDlgButton(hWndDlg,IDC_BANDPASS2,1);
	if (lpAmp->FiltType2=='A') CheckDlgButton(hWndDlg,IDC_AWEIGHT2,1);
	if (lpAmp->FiltType2=='W') CheckDlgButton(hWndDlg,IDC_ACCWEIGHT2,1);
	if (lpAmp->FiltType2=='V') CheckDlgButton(hWndDlg,IDC_UNIWEIGHT2,1);
	if (lpAmp->FiltType2=='E') CheckDlgButton(hWndDlg,IDC_VELWEIGHT2,1);
	
	// Remove DC
	if (lpAmp->RemoveDC) CheckDlgButton(hWndDlg,IDC_REMOVEDC,1);
	
	// inizializzo la Calibrazione sempre su FullScale
	CheckDlgButton(hWndDlg,IDC_RADIO_FS,1);    
	lpAmp->CALtype='F'; // Forzo il modo di calibrazione di Default

    // inizializzo il valore in dB del FS
    sprintf(textbuf,"%.2f",lpAmp->LFS);
	SetDlgItemText(hWndDlg,IDC_LFS,textbuf); 
    sprintf(textbuf,"%.2f",lpAmp->RFS);
	SetDlgItemText(hWndDlg,IDC_RFS,textbuf); 

	// Se  mono, nascondo i controlli "Right"
	if (ci->wChannels==1)
	{
		ShowWindow(GetDlgItem(hWndDlg,IDC_LabLeft),SW_HIDE);
		ShowWindow(GetDlgItem(hWndDlg,IDC_LabRight),SW_HIDE);
		ShowWindow(GetDlgItem(hWndDlg,IDC_RFS),SW_HIDE);
		ShowWindow(GetDlgItem(hWndDlg,IDC_BANDPASS2),SW_HIDE);
		ShowWindow(GetDlgItem(hWndDlg,IDC_AWEIGHT2),SW_HIDE);
		ShowWindow(GetDlgItem(hWndDlg,IDC_ACCWEIGHT2),SW_HIDE);
		ShowWindow(GetDlgItem(hWndDlg,IDC_UNIWEIGHT2),SW_HIDE);
		ShowWindow(GetDlgItem(hWndDlg,IDC_VELWEIGHT2),SW_HIDE);
		ShowWindow(GetDlgItem(hWndDlg,IDC_RIGHT),SW_HIDE);
	}

    // Registrazione del modulo
	SetDlgItemText(hWndDlg,IDC_USERNAME,lpAmp->username); 
    SetDlgItemText(hWndDlg,IDC_REGKEY,lpAmp->regkey); 

}    

void CopyToDlgItem(HWND hWndDlg, short iControl,COOLINFO far *ci,HANDLE hAmplify,MLS FAR *lpAmp)
{   char m[80];
	wsprintf(m,"%ld,%d,%ld",lpAmp,hAmplify,ci);
	SetDlgItemText(hWndDlg,iControl,m);	
}                                      

void CopyFromDlgItem(HWND hWndDlg, short iControl,  COOLINFO far **ci, HANDLE *hAmplify,MLS FAR **lpAmp)
{	char m[80];
	char *cursor;         
	GetDlgItemText(hWndDlg,iControl,m,80);
	if (m[0]==0x00)
	{	*lpAmp=NULL;
		*hAmplify=0;
		*ci=NULL;
		return;
	}          
	cursor=m;
	*lpAmp=(MLS FAR *)longfromstring(&cursor);
	*hAmplify=(HANDLE)longfromstring(&cursor);
	*ci=(COOLINFO far *)longfromstring(&cursor);
	
}

__declspec(dllexport) BOOL FAR PASCAL DIALOGMsgProc(HWND hWndDlg, UINT Message, WPARAM wParam, LPARAM lParam)
{   MLS FAR * lpAmp = NULL;
	HANDLE hTones = NULL;
	COOLINFO far *ci=NULL;
	short booltoreturn=FALSE;
	char textbuf[40];
	
	switch(Message)
   	{	case WM_INITDIALOG:
		{	ci=(COOLINFO far *)lParam;
			hTones=ci->hUserData;         
			lpAmp=(MLS FAR *)GlobalLock(hTones);
			
			CopyToDlgItem(hWndDlg,IDC_STORAGE,ci,hTones,lpAmp);
	        
			CenterDialog(ci,hWndDlg);
	        
			StructToDialog(ci, lpAmp, hWndDlg);
			
	 		// using scripts, auto OK it.
	 		if ((ci->iScriptFile!=-1) && (!ci->iScriptDialogStop))
		 		PostMessage(hWndDlg,WM_COMMAND,IDOK,0L);
	
		}    		
        break; /* End of WM_INITDIALOG                                 */

    case WM_CLOSE:
         /* Closing the Dialog behaves the same as Cancel               */
         PostMessage(hWndDlg, WM_COMMAND, IDCANCEL, 0L);
         break; 
    case WM_COMMAND:
         CopyFromDlgItem(hWndDlg,IDC_STORAGE,&ci,&hTones,&lpAmp);
	     switch(LOWORD(wParam))
           { 
			case ID_HLP:
           		 WinHelp(hWndDlg,XFM_HELPFILE,HELP_KEY,(DWORD)((LPSTR)"ITU P56 Active Speech Level"));
                 break;  
          	case IDOK:
              	 DialogToStruct(ci, hWndDlg,lpAmp);
                 GlobalUnlock(hTones); 
             	 hTones=NULL;
                 EndDialog(hWndDlg,TRUE);	
               	 break;                                                    
            case IDCANCEL:
                 /* Ignore data values entered into the controls        */
                 /* and dismiss the dialog window returning FALSE       */
                 GlobalUnlock(hTones);
                 hTones=NULL;
                 EndDialog(hWndDlg, FALSE);
                 break;
            case IDC_RADIO_FS:
				 // inizializzo il valore in dB del FS
				 sprintf(textbuf,"%.2f",lpAmp->LFS);
				 SetDlgItemText(hWndDlg,IDC_LFS,textbuf); 
			     sprintf(textbuf,"%.2f",lpAmp->RFS);
				 SetDlgItemText(hWndDlg,IDC_RFS,textbuf); 
				 break;
            case IDC_RADIO_Leq:
				 // inizializzo il valore in dB del FS
			     sprintf(textbuf,"%.2f",lpAmp->LCal);
				 SetDlgItemText(hWndDlg,IDC_LFS,textbuf); 
			     sprintf(textbuf,"%.2f",lpAmp->RCal);
				 SetDlgItemText(hWndDlg,IDC_RFS,textbuf); 
				 break;
			case IDC_BANDPASS:
					if (IsDlgButtonChecked(hWndDlg,IDC_BANDPASS)) 
					{
						CheckDlgButton(hWndDlg,IDC_AWEIGHT,0);    
						CheckDlgButton(hWndDlg,IDC_ACCWEIGHT,0);    
						CheckDlgButton(hWndDlg,IDC_UNIWEIGHT,0);    
						CheckDlgButton(hWndDlg,IDC_VELWEIGHT,0);    
					}
				 break;	
			case IDC_BANDPASS2:
					if (IsDlgButtonChecked(hWndDlg,IDC_BANDPASS2)) 
					{
						CheckDlgButton(hWndDlg,IDC_AWEIGHT2,0);    
						CheckDlgButton(hWndDlg,IDC_ACCWEIGHT2,0);    
						CheckDlgButton(hWndDlg,IDC_UNIWEIGHT2,0);    
						CheckDlgButton(hWndDlg,IDC_VELWEIGHT2,0);    
					}
				 break;	
			case IDC_AWEIGHT:
					if (IsDlgButtonChecked(hWndDlg,IDC_AWEIGHT)) 
					{
						CheckDlgButton(hWndDlg,IDC_BANDPASS,0);    
						CheckDlgButton(hWndDlg,IDC_ACCWEIGHT,0);    
						CheckDlgButton(hWndDlg,IDC_UNIWEIGHT,0);    
						CheckDlgButton(hWndDlg,IDC_VELWEIGHT,0);    
					}
				 break;	
			case IDC_AWEIGHT2:
					if (IsDlgButtonChecked(hWndDlg,IDC_AWEIGHT2)) 
					{
						CheckDlgButton(hWndDlg,IDC_BANDPASS2,0);    
						CheckDlgButton(hWndDlg,IDC_ACCWEIGHT2,0);    
						CheckDlgButton(hWndDlg,IDC_UNIWEIGHT2,0);    
						CheckDlgButton(hWndDlg,IDC_VELWEIGHT2,0);    
					}
				 break;	
			case IDC_ACCWEIGHT:
					if (IsDlgButtonChecked(hWndDlg,IDC_ACCWEIGHT)) 
					{
						CheckDlgButton(hWndDlg,IDC_BANDPASS,0);    
						CheckDlgButton(hWndDlg,IDC_AWEIGHT,0);    
						CheckDlgButton(hWndDlg,IDC_UNIWEIGHT,0);    
						CheckDlgButton(hWndDlg,IDC_VELWEIGHT,0);    
					}
				 break;	
			case IDC_ACCWEIGHT2:
					if (IsDlgButtonChecked(hWndDlg,IDC_ACCWEIGHT2)) 
					{
						CheckDlgButton(hWndDlg,IDC_BANDPASS2,0);    
						CheckDlgButton(hWndDlg,IDC_AWEIGHT2,0);    
						CheckDlgButton(hWndDlg,IDC_UNIWEIGHT2,0);    
						CheckDlgButton(hWndDlg,IDC_VELWEIGHT2,0);    
					}
				 break;	
			case IDC_UNIWEIGHT:
					if (IsDlgButtonChecked(hWndDlg,IDC_UNIWEIGHT)) 
					{
						CheckDlgButton(hWndDlg,IDC_BANDPASS,0);    
						CheckDlgButton(hWndDlg,IDC_AWEIGHT,0);    
						CheckDlgButton(hWndDlg,IDC_ACCWEIGHT,0);    
						CheckDlgButton(hWndDlg,IDC_VELWEIGHT,0);    
					}
				 break;	
			case IDC_UNIWEIGHT2:
					if (IsDlgButtonChecked(hWndDlg,IDC_UNIWEIGHT2)) 
					{
						CheckDlgButton(hWndDlg,IDC_BANDPASS2,0);    
						CheckDlgButton(hWndDlg,IDC_AWEIGHT2,0);    
						CheckDlgButton(hWndDlg,IDC_ACCWEIGHT2,0);    
						CheckDlgButton(hWndDlg,IDC_VELWEIGHT2,0);    
					}
				 break;	
			case IDC_VELWEIGHT:
					if (IsDlgButtonChecked(hWndDlg,IDC_VELWEIGHT)) 
					{
						CheckDlgButton(hWndDlg,IDC_BANDPASS,0);    
						CheckDlgButton(hWndDlg,IDC_AWEIGHT,0);    
						CheckDlgButton(hWndDlg,IDC_ACCWEIGHT,0);    
						CheckDlgButton(hWndDlg,IDC_UNIWEIGHT,0);    
					}
				 break;	
			case IDC_VELWEIGHT2:
					if (IsDlgButtonChecked(hWndDlg,IDC_VELWEIGHT2)) 
					{
						CheckDlgButton(hWndDlg,IDC_BANDPASS2,0);    
						CheckDlgButton(hWndDlg,IDC_AWEIGHT2,0);    
						CheckDlgButton(hWndDlg,IDC_ACCWEIGHT2,0);    
						CheckDlgButton(hWndDlg,IDC_UNIWEIGHT2,0);    
					}
				 break;	


		 }
         break;    /* End of WM_COMMAND                                 */

    default:
		return FALSE;
   }
 	return TRUE;
}   

void ShowParameters(HWND hWndDlg,MLS FAR *lpAmp)
{
	char yes[]="yes";
	char no[]="no";      
	char lin[]="- - -";
	char textbuf[40],textbuf2[80];
	double Dur=(double)lpAmp->N/(double)lpAmp->SampRate; // Durata in secondi della Time History

	// Left - Mono
	sprintf(textbuf,"%.2f",lpAmp->LFS);
	SetDlgItemText(hWndDlg,IDC_L_FS,textbuf);
    sprintf(textbuf,"%.2f",lpAmp->LLeq);
	SetDlgItemText(hWndDlg,IDC_L_Leq,textbuf);
    sprintf(textbuf,"%.2f",lpAmp->LLeq+10.0*log10(Dur));
	SetDlgItemText(hWndDlg,IDC_L_SEL,textbuf);
    sprintf(textbuf,"%.2f",Dur);
	SetDlgItemText(hWndDlg,IDC_L_TDUR,textbuf);
	if ((lpAmp->LAR>0.05)&&(lpAmp->LAR<0.95))
	    sprintf(textbuf,"%.2f",lpAmp->LASL);
	else
	    strcpy(textbuf,"- - -");
	SetDlgItemText(hWndDlg,IDC_L_ASL,textbuf);
    sprintf(textbuf,"%.2f",lpAmp->LTHR);
	SetDlgItemText(hWndDlg,IDC_L_THR,textbuf);
    sprintf(textbuf,"%.1f",(lpAmp->LAR*Dur));
	SetDlgItemText(hWndDlg,IDC_L_AF,textbuf);
	if ((lpAmp->LAR>0.05)&&(lpAmp->LAR<0.95))
	    sprintf(textbuf,"%.2f",lpAmp->LBACK);
	else
	    strcpy(textbuf,"- - -");
	SetDlgItemText(hWndDlg,IDC_L_BACK,textbuf);
	if ((lpAmp->LAR>0.05)&&(lpAmp->LAR<0.95))
	    sprintf(textbuf,"%.2f",lpAmp->LSNR);
	else
	    strcpy(textbuf,"- - -");
	SetDlgItemText(hWndDlg,IDC_L_SNR,textbuf);
    sprintf(textbuf,"%.2f",lpAmp->LMaxPeak);
	SetDlgItemText(hWndDlg,IDC_L_MaxPeak,textbuf);
    sprintf(textbuf,"%.2f",lpAmp->LMaxImp);
	SetDlgItemText(hWndDlg,IDC_L_MaxImp,textbuf);
    sprintf(textbuf,"%.2f",lpAmp->LMaxFast);
	SetDlgItemText(hWndDlg,IDC_L_MaxFast,textbuf);
    sprintf(textbuf,"%.2f",lpAmp->LMaxSlow);
	SetDlgItemText(hWndDlg,IDC_L_MaxSlow,textbuf);
    sprintf(textbuf,"%.3f",lpAmp->LDur);
	SetDlgItemText(hWndDlg,IDC_L_DUR,textbuf);
    if (lpAmp->LImpFlag) SetDlgItemText(hWndDlg,IDC_L_ImpFlag,yes); else SetDlgItemText(hWndDlg,IDC_L_ImpFlag,no);
	if (lpAmp->FiltType=='L') strcpy(textbuf2,"Wide Band");
	if (lpAmp->FiltType=='B') strcpy(textbuf2,"ITU BandPass");
	if (lpAmp->FiltType=='A') strcpy(textbuf2,"IEC A-weighting");
	if (lpAmp->FiltType=='W') strcpy(textbuf2,"ISO Wm");
	if (lpAmp->FiltType=='V') strcpy(textbuf2,"UNI LP 250Hz");
	if (lpAmp->FiltType=='E') strcpy(textbuf2,"UNI VEL1");
	
	if (lpAmp->DispType=='P') CheckDlgButton(hWndDlg,IDC_PEAK,1);
	if (lpAmp->DispType=='1') CheckDlgButton(hWndDlg,IDC_INST,1);
	if (lpAmp->DispType=='3') CheckDlgButton(hWndDlg,IDC_30MS,1);
	if (lpAmp->DispType=='F') CheckDlgButton(hWndDlg,IDC_FAST,1);
	if (lpAmp->DispType=='S') CheckDlgButton(hWndDlg,IDC_SLOW,1);
	if (lpAmp->DispType=='I') CheckDlgButton(hWndDlg,IDC_IMP,1);
	if (lpAmp->wChannels==2) 
	// Right
    {
	    sprintf(textbuf,"%.2f",lpAmp->RFS);
		SetDlgItemText(hWndDlg,IDC_R_FS,textbuf);
	    sprintf(textbuf,"%.2f",lpAmp->RLeq);
		SetDlgItemText(hWndDlg,IDC_R_Leq,textbuf);
		sprintf(textbuf,"%.2f",lpAmp->RLeq+10.0*log10(Dur));
		SetDlgItemText(hWndDlg,IDC_R_SEL,textbuf);
		sprintf(textbuf,"%.2f",Dur);
		SetDlgItemText(hWndDlg,IDC_R_TDUR,textbuf);
	    sprintf(textbuf,"%.2f",lpAmp->RASL);
		SetDlgItemText(hWndDlg,IDC_R_ASL,textbuf);
	    sprintf(textbuf,"%.2f",lpAmp->RTHR);
		SetDlgItemText(hWndDlg,IDC_R_THR,textbuf);
	    sprintf(textbuf,"%.1f",(lpAmp->RAR*Dur));
		SetDlgItemText(hWndDlg,IDC_R_AF,textbuf);
		sprintf(textbuf,"%.2f",lpAmp->RBACK);
		SetDlgItemText(hWndDlg,IDC_R_BACK,textbuf);
		sprintf(textbuf,"%.2f",lpAmp->RSNR);
		SetDlgItemText(hWndDlg,IDC_R_SNR,textbuf);
	    sprintf(textbuf,"%.2f",lpAmp->RMaxPeak);
		SetDlgItemText(hWndDlg,IDC_R_MaxPeak,textbuf);
	    sprintf(textbuf,"%.2f",lpAmp->RMaxImp);
		SetDlgItemText(hWndDlg,IDC_R_MaxImp,textbuf);
	    sprintf(textbuf,"%.2f",lpAmp->RMaxFast);
		SetDlgItemText(hWndDlg,IDC_R_MaxFast,textbuf);
	    sprintf(textbuf,"%.2f",lpAmp->RMaxSlow);
		SetDlgItemText(hWndDlg,IDC_R_MaxSlow,textbuf);
	    sprintf(textbuf,"%.3f",lpAmp->RDur);
		SetDlgItemText(hWndDlg,IDC_R_DUR,textbuf);
	    if (lpAmp->RImpFlag) SetDlgItemText(hWndDlg,IDC_R_ImpFlag,yes); else SetDlgItemText(hWndDlg,IDC_R_ImpFlag,no);
		if (lpAmp->FiltType2=='L') strcat(textbuf2," | Wide Band");
		if (lpAmp->FiltType2=='B') strcat(textbuf2," | ITU BandPass");
		if (lpAmp->FiltType2=='A') strcat(textbuf2," | IEC A-weighting");
		if (lpAmp->FiltType2=='W') strcat(textbuf2," | ISO Wm");
		if (lpAmp->FiltType2=='V') strcat(textbuf2," | UNI LP 250Hz");
		if (lpAmp->FiltType2=='E') strcat(textbuf2," | UNI VEL1");
		if (lpAmp->Avg)
		{
			CheckDlgButton(hWndDlg,IDC_AVG,1);    
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LLeq/10.0)+pow(10.0,lpAmp->RLeq/10.0))/2.0));
			SetDlgItemText(hWndDlg,IDC_A_Leq,textbuf);
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LLeq/10.0)+pow(10.0,lpAmp->RLeq/10.0))/2.0)+10.0*log10(Dur));
			SetDlgItemText(hWndDlg,IDC_A_SEL,textbuf);
			sprintf(textbuf,"%.2f",Dur);
			SetDlgItemText(hWndDlg,IDC_A_TDUR,textbuf);
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LASL/10.0)+pow(10.0,lpAmp->RASL/10.0))/2.0));
			SetDlgItemText(hWndDlg,IDC_A_ASL,textbuf);
			sprintf(textbuf,"%.2f",(lpAmp->RTHR+lpAmp->RTHR)/2.0);
			SetDlgItemText(hWndDlg,IDC_A_THR,textbuf);
			sprintf(textbuf,"%.1f",(lpAmp->LAR+lpAmp->RAR)/2.0*Dur);
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LBACK/10.0)+pow(10.0,lpAmp->RBACK/10.0))/2.0));
			SetDlgItemText(hWndDlg,IDC_A_BACK,textbuf);
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LSNR/10.0)+pow(10.0,lpAmp->RSNR/10.0))/2.0));
			SetDlgItemText(hWndDlg,IDC_A_SNR,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_AF,textbuf);
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LMaxPeak/10.0)+pow(10.0,lpAmp->RMaxPeak/10.0))/2.0));
			SetDlgItemText(hWndDlg,IDC_A_MaxPeak,textbuf);
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LMaxImp/10.0)+pow(10.0,lpAmp->RMaxImp/10.0))/2.0));
			SetDlgItemText(hWndDlg,IDC_A_MaxImp,textbuf);
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LMaxFast/10.0)+pow(10.0,lpAmp->RMaxFast/10.0))/2.0));
			SetDlgItemText(hWndDlg,IDC_A_MaxFast,textbuf);
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LMaxSlow/10.0)+pow(10.0,lpAmp->RMaxSlow/10.0))/2.0));
			SetDlgItemText(hWndDlg,IDC_A_MaxSlow,textbuf);
			sprintf(textbuf,"%.3f",(lpAmp->LDur+lpAmp->RDur)/2.0);
			SetDlgItemText(hWndDlg,IDC_A_DUR,textbuf);
			if ((lpAmp->LImpFlag)|(lpAmp->RImpFlag)) SetDlgItemText(hWndDlg,IDC_A_ImpFlag,yes); else SetDlgItemText(hWndDlg,IDC_A_ImpFlag,no);
		}
		else
		{
			CheckDlgButton(hWndDlg,IDC_AVG,0);    
			strcpy(textbuf,"- - -");
			SetDlgItemText(hWndDlg,IDC_A_Leq,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_SEL,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_TDUR,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_ASL,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_THR,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_AF,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_BACK,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_SNR,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_MaxPeak,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_MaxImp,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_MaxFast,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_MaxSlow,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_DUR,textbuf);
			SetDlgItemText(hWndDlg,IDC_A_ImpFlag,textbuf); 
		}
    }
	SetDlgItemText(hWndDlg,IDC_FILTER,textbuf2);
}   


void 	AcousticsToClipboard(char *Clipdata,MLS FAR *lpAmp)
{                                                                                 
	CRLFDEF;
	VTABDEF; 
	char yes[]="yes";
	char no[]="no";      
	char textbuf[40];
	long nChan=lpAmp->wChannels;
	double Dur=(double)lpAmp->N/(double)lpAmp->SampRate; // Durata in secondi della Time History

    // copio i parametri nella Clipboard
	strcpy(Clipdata,"Aurora 4.4 - Results of ITU-T P56 Calculations");CRLF;

    // nome canale e nome parametri
    strcat(Clipdata,"Channel");VTAB;
	strcat(Clipdata,"Leq (dB)");VTAB;
	strcat(Clipdata,"SEL (dB)");VTAB;
	strcat(Clipdata,"Active Speech Level (dB)");VTAB;
	strcat(Clipdata,"Speech/Noise Threshold (dB)");VTAB;
	strcat(Clipdata,"Backround Noise (dB)");VTAB;
	strcat(Clipdata,"SNR - Speech-Noise Ratio (dB)");VTAB;
	strcat(Clipdata,"Total Length (s)");VTAB;
	strcat(Clipdata,"Net Speech Length (s)");VTAB;
	strcat(Clipdata,"Max Peak SPL (dB)");VTAB;
	strcat(Clipdata,"Max Impulse SPL (dB)");VTAB;
	strcat(Clipdata,"Max Fast SPL (dB)");VTAB;
	strcat(Clipdata,"Max Slow SPL (dB)");VTAB;
	strcat(Clipdata,"Event Duration (s)");VTAB;
	strcat(Clipdata,"Impulsive Event");VTAB;
	strcat(Clipdata,"Peakiness (dB)");VTAB;
	strcat(Clipdata,"Impulsiveness (dB)");VTAB;
	strcat(Clipdata,"Millisecondness (dB)");CRLF;

	if (nChan==1)
    {
		strcat(Clipdata,"Mono");VTAB;							//Channel
	}
	else
    {
		strcat(Clipdata,"Left");VTAB;							//Channel
	}

	sprintf(textbuf,"%.2f",lpAmp->LLeq);					//Leq
	strcat(Clipdata,textbuf);VTAB;							
	sprintf(textbuf,"%.2f",(lpAmp->LLeq+10.0*log10(Dur)));	//SEL
	strcat(Clipdata,textbuf);VTAB;
	if ((lpAmp->LAR>0.05)&&(lpAmp->LAR<0.95))
		sprintf(textbuf,"%.2f",lpAmp->LASL);					//Active Speech Level
	else
	    strcpy(textbuf,"- - -");
	strcat(Clipdata,textbuf);VTAB;
	sprintf(textbuf,"%.2f",lpAmp->LTHR);					//Threshold
	strcat(Clipdata,textbuf);VTAB;
	if ((lpAmp->LAR>0.05)&&(lpAmp->LAR<0.95))
		sprintf(textbuf,"%.2f",lpAmp->LBACK);					//Background Noise
	else
	    strcpy(textbuf,"- - -");
	strcat(Clipdata,textbuf);VTAB;
	if ((lpAmp->LAR>0.05)&&(lpAmp->LAR<0.95))
		sprintf(textbuf,"%.2f",lpAmp->LSNR);					//SNR
	else
	    strcpy(textbuf,"- - -");
	strcat(Clipdata,textbuf);VTAB;
    sprintf(textbuf,"%.2f",Dur);							//Total Length
	strcat(Clipdata,textbuf);VTAB;
    sprintf(textbuf,"%.1f",lpAmp->LAR*Dur);					//Net Speech Length
	strcat(Clipdata,textbuf);VTAB;
    sprintf(textbuf,"%.2f",lpAmp->LMaxPeak);				//Max Peak
	strcat(Clipdata,textbuf);VTAB;
    sprintf(textbuf,"%.2f",lpAmp->LMaxImp);					//Max Imp
	strcat(Clipdata,textbuf);VTAB;
    sprintf(textbuf,"%.2f",lpAmp->LMaxFast);				//Max Fast
	strcat(Clipdata,textbuf);VTAB;
    sprintf(textbuf,"%.2f",lpAmp->LMaxSlow);				//Max Slow
	strcat(Clipdata,textbuf);VTAB;
    sprintf(textbuf,"%.3f",lpAmp->LDur);					//Event Duration
	strcat(Clipdata,textbuf);VTAB;
    if (lpAmp->LImpFlag) strcat(Clipdata,yes); else strcat (Clipdata,no); //Impulsive Event?
	VTAB;
    sprintf(textbuf,"%.2f",lpAmp->LMaxPeak-lpAmp->LASL);    //Peakiness = MaxPeak-ASL
	strcat(Clipdata,textbuf);VTAB;
    sprintf(textbuf,"%.2f",lpAmp->LMaxImp-lpAmp->LASL);		//Impulsiveness = MaxImp-ASL
	strcat(Clipdata,textbuf);VTAB;
    sprintf(textbuf,"%.2f",lpAmp->LMax1ms-lpAmp->LASL);		//Millisecondness = Max1ms-ASL
	strcat(Clipdata,textbuf);VTAB;
	CRLF;

	if (nChan==2)
	{
    	// Stereo, scrivo il canale right
		strcat(Clipdata,"Right");VTAB;
	    sprintf(textbuf,"%.2f",lpAmp->RLeq);					//Leq
		strcat(Clipdata,textbuf);VTAB;
	    sprintf(textbuf,"%.2f",(lpAmp->RLeq+10.0*log10(Dur)));	//SEL
		strcat(Clipdata,textbuf);VTAB;
	    sprintf(textbuf,"%.2f",lpAmp->RASL);					//ASL
		strcat(Clipdata,textbuf);VTAB;
	    sprintf(textbuf,"%.2f",lpAmp->RTHR);					//Threshold
		strcat(Clipdata,textbuf);VTAB;
		sprintf(textbuf,"%.2f",lpAmp->RBACK);					//Background Noise
		strcat(Clipdata,textbuf);VTAB;
		sprintf(textbuf,"%.2f",lpAmp->RSNR);					//SNR
		strcat(Clipdata,textbuf);VTAB;
	    sprintf(textbuf,"%.2f",Dur);							//Total Length
		strcat(Clipdata,textbuf);VTAB;
	    sprintf(textbuf,"%.1f",lpAmp->RAR*Dur);					//Net Speech Length
		strcat(Clipdata,textbuf);VTAB;
	    sprintf(textbuf,"%.2f",lpAmp->RMaxPeak);				//Max Peak
		strcat(Clipdata,textbuf);VTAB;
	    sprintf(textbuf,"%.2f",lpAmp->RMaxImp);					//Max Imp
		strcat(Clipdata,textbuf);VTAB;
	    sprintf(textbuf,"%.2f",lpAmp->RMaxFast);				//Max Fast
		strcat(Clipdata,textbuf);VTAB;
	    sprintf(textbuf,"%.2f",lpAmp->RMaxSlow);				//Max Slow
		strcat(Clipdata,textbuf);VTAB;
	    sprintf(textbuf,"%.3f",lpAmp->RDur);					//Event Duration
		strcat(Clipdata,textbuf);VTAB;
	    if (lpAmp->RImpFlag) strcat(Clipdata,yes); else strcat (Clipdata,no); //Impulsive Event?
		VTAB;
	    sprintf(textbuf,"%.2f",lpAmp->RMaxPeak-lpAmp->RASL);	//Peakiness = MaxPeak-ASL
		strcat(Clipdata,textbuf);VTAB;
	    sprintf(textbuf,"%.2f",lpAmp->RMaxImp-lpAmp->RASL);		//Impulsiveness = MaxImp-ASL
		strcat(Clipdata,textbuf);VTAB;
	    sprintf(textbuf,"%.2f",lpAmp->RMax1ms-lpAmp->RASL);		//Millisecondness = Max1ms-ASL
		strcat(Clipdata,textbuf);VTAB;
		CRLF;
		if (lpAmp->Avg)
		{
    		// parametri Media
			strcat(Clipdata,"Average");VTAB;
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LLeq/10.0)+pow(10.0,lpAmp->RLeq/10.0))/2.0));
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.2f",(10.0*log10((pow(10.0,lpAmp->LLeq/10.0)+pow(10.0,lpAmp->RLeq/10.0))/2.0)+10.0*log10(Dur)));
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LASL/10.0)+pow(10.0,lpAmp->RASL/10.0))/2.0));
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.2f",(lpAmp->RTHR+lpAmp->RTHR)/2.0);
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LBACK/10.0)+pow(10.0,lpAmp->RBACK/10.0))/2.0));					//Background Noise
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LSNR/10.0)+pow(10.0,lpAmp->RSNR/10.0))/2.0));					//SNR
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.2f",Dur);
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.1f",(lpAmp->LAR+lpAmp->RAR)/2.0*Dur);
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LMaxPeak/10.0)+pow(10.0,lpAmp->RMaxPeak/10.0))/2.0));
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LMaxImp/10.0)+pow(10.0,lpAmp->RMaxImp/10.0))/2.0));
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LMaxFast/10.0)+pow(10.0,lpAmp->RMaxFast/10.0))/2.0));
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LMaxSlow/10.0)+pow(10.0,lpAmp->RMaxSlow/10.0))/2.0));
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.3f",(lpAmp->LDur+lpAmp->RDur)/2.0);
			strcat(Clipdata,textbuf);VTAB;
			if ((lpAmp->LImpFlag)|(lpAmp->RImpFlag)) strcat(Clipdata,yes); else strcat (Clipdata,no);
			VTAB;
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LMaxPeak/10.0)+pow(10.0,lpAmp->RMaxPeak/10.0))/2.0)-10.0*log10((pow(10.0,lpAmp->LASL/10.0)+pow(10.0,lpAmp->RASL/10.0))/2.0)); // Peakiness = MaxPeak-ASL
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LMaxImp/10.0)+pow(10.0,lpAmp->RMaxImp/10.0))/2.0)-10.0*log10((pow(10.0,lpAmp->LASL/10.0)+pow(10.0,lpAmp->RASL/10.0))/2.0));  // Impulsiveness = MaxImp-ASL
			strcat(Clipdata,textbuf);VTAB;
			sprintf(textbuf,"%.2f",10.0*log10((pow(10.0,lpAmp->LMax1ms/10.0)+pow(10.0,lpAmp->RMax1ms/10.0))/2.0)-10.0*log10((pow(10.0,lpAmp->LASL/10.0)+pow(10.0,lpAmp->RASL/10.0))/2.0));  // Millisecondness = Max1ms-ASL
			strcat(Clipdata,textbuf);VTAB;
			CRLF;
		}
	}
    strcat(Clipdata,"\0"); //Aggiungo uno zero finale
}                       

__declspec(dllexport) DWORD FAR PASCAL DisplayCallback(double fXpos, MLS FAR *lpAmp,
WORD wChartNumber, double * pfYpos)
{
	float far *fBufLeft;
	float far *fBufRight;
	long i;
    long Npstep=(long)(lpAmp->SampRate/1000.0);   // N. di campioni che fanno circa 1ms
	long Nstep=lpAmp->N/Npstep;                   // Numero di steps
//  char textbuf[40],ftext[20];
	DWORD RetVal;
	switch (lpAmp->DispType)
	{
		case '1':
			fBufLeft =(float far *)lpAmp->LeftBufInst;  //puntatore alla Time History Left
			fBufRight=(float far *)lpAmp->RightBufInst; //puntatore alla Time History Right
			break;
		case '3':
			fBufLeft =(float far *)lpAmp->LeftBuf30ms;  //puntatore alla Time History Left
			fBufRight=(float far *)lpAmp->RightBuf30ms; //puntatore alla Time History Right
			break;
		case 'F':
			fBufLeft =(float far *)lpAmp->LeftBufFast;  //puntatore alla Time History Left
			fBufRight=(float far *)lpAmp->RightBufFast; //puntatore alla Time History Right
			break;
		case 'S':
			fBufLeft =(float far *)lpAmp->LeftBufSlow;  //puntatore alla Time History Left
			fBufRight=(float far *)lpAmp->RightBufSlow; //puntatore alla Time History Right
			break;
		case 'I':
			fBufLeft =(float far *)lpAmp->LeftBufImp;   //puntatore alla Time History Left
			fBufRight=(float far *)lpAmp->RightBufImp;  //puntatore alla Time History Right
			break;
		case 'P':
			fBufLeft =(float far *)lpAmp->LeftBufPeak;   //puntatore alla Time History Left
			fBufRight=(float far *)lpAmp->RightBufPeak;  //puntatore alla Time History Right
			break;
		default:
			fBufLeft =(float far *)lpAmp->LeftBufInst;  //puntatore alla Time History Left
			fBufRight=(float far *)lpAmp->RightBufInst; //puntatore alla Time History Right
			break;
	}
	// i=(long)(Nstep*fXpos*lpAmp->SampRate/lpAmp->N); // originale, step=1ms
	i=(long)(fXpos*1000.0); // modificato - d direttamente il valore in ms
							// poich fXpos  gi un valore in secondi
	if (i>=Nstep) i=Nstep-1;   // per sicurezza, non si sa mai....
	RetVal=TRUE;
	switch(wChartNumber)
   	{	
		case 1:
			// IR Left - Cyan
			*pfYpos=fBufLeft[i]+lpAmp->LFS;// SPL istantaneo Fast Left
			break;
   		case 2:
			// IR Right - Violet
			*pfYpos=fBufRight[i]+lpAmp->RFS;// SPL istantaneo Fast Right
			break;
		default:
			// non trovato
			*pfYpos=-200.0; //lo faccio puntare al nulla....
			RetVal=FALSE;
			break;
	}
	return RetVal;
}

void SaveParams(COOLINFO *ci,MLS *lpAmp)
{
	CRLFDEF;
	VTABDEF; 
	HWND			hWndDlg=lpAmp->hWnd;
	OPENFILENAME	ofn;				// serve per aprire la common dialog
	char			szPathname[256];	// memorizza il path del file da salvare
	char			szFileName[256];	// memorizza il nome del file da salvare
	BOOL			FileOK;				// TRUE se ho selezionato un file dalla common dialog
	char			*IRpath = NULL;		// puntatore al path della IR da caricare
	char			*cp = NULL;
	DWORD			counter = 0;
	LPCTSTR			lpLastDir; // da aggiungere
	long            Error;
	char            ErrorString[256];
	char			Clipdata[8192];
	HANDLE			hResults;
	DWORD           lpWritten=0;
	char			bResult=TRUE;
	char			textbuf[256];
	long			N=0;
	DWORD			FormatNum;
	char			ExistFlag=FALSE;

	float			far *fBuf;
	long			i;
    long			Npstep=(long)(lpAmp->SampRate/1000.0);   // N. di campioni che fanno circa 1ms
	long			Nstep=lpAmp->N/Npstep;                   // Numero di steps
	double			CurTime=0.0;
	double			Dtau=(double)(Npstep*(1.0/lpAmp->SampRate));	// Lunghezza effettiva in s di ciascuno step

    // Recupero le informazioni da lpAmp
	lpLastDir = (LPCTSTR)lpAmp->LastIRDir; 
	strcpy(szFileName, lpAmp->cName); // Nome del salvataggio precedente

	// inizializzo la struttura OPENFILENAME
	memset(&ofn, 0, sizeof(ofn));
	ofn.lStructSize     = sizeof(ofn);
	ofn.hwndOwner       = hWndDlg;
	ofn.lpstrFilter     = "Parameter Files (*.txt)\0*.txt\0Time History (*.txt)\0*.txt\0\0\0";
	ofn.nFilterIndex    = 2;

	strcpy(szPathname, lpAmp->cName); // Nome del salvataggio precedente
	ofn.lpstrFile       = szPathname; 	
	ofn.nMaxFile        = sizeof(szPathname);
	ofn.lpstrTitle      = "Save Results to File";
	ofn.Flags           = OFN_LONGNAMES|OFN_NOREADONLYRETURN|OFN_HIDEREADONLY|OFN_OVERWRITEPROMPT;
	ofn.lpstrFileTitle	= szFileName;
	ofn.lpstrInitialDir = lpLastDir;
	// MessageBox(NULL,lpLastDir,"Initial Dir",MB_ICONSTOP|MB_OK);


	// visualizzo la common dialog "Save File"
	FileOK = GetSaveFileName(&ofn);

	// se ho selezionato un file dalla common dialog
	if (!FileOK)
		return ;

	// Copio il numero del formato.
	FormatNum=ofn.nFilterIndex;

	// copio il nome del file nella struttura lpAmp
	strcpy(lpAmp->IRFilePath,szPathname); // path + filename
	strcpy(lpAmp->cName,szFileName);     // nome del file senza Path

	IRpath = szPathname;

	// costruisco la stringa che memorizza l'ultima directory
	// in cui ho salvato i parametri
	strcpy(lpAmp->LastIRDir,"");
	strncpy(lpAmp->LastIRDir, ofn.lpstrFile, ofn.nFileOffset);
	lpAmp->LastIRDir[ofn.nFileOffset] = '\0';

	// MessageBox(hWndDlg, "Pronto ad aprire il file", "File Access", MB_OK|MB_ICONEXCLAMATION);

	hResults = CreateFile((LPCSTR)IRpath,GENERIC_READ|GENERIC_WRITE,0,(LPSECURITY_ATTRIBUTES)NULL,
		                          CREATE_ALWAYS,FILE_ATTRIBUTE_NORMAL,(HANDLE)NULL);
	Error = GetLastError();

	if (Error == ERROR_SHARING_VIOLATION)
	{
		strcpy(ErrorString, IRpath);
		strcat(ErrorString, "\nis alredy in use by another process.\n\nChoose another file, please!");
		MessageBox(hWndDlg, ErrorString, "File Access Error", MB_OK|MB_ICONEXCLAMATION);
		return ;
	}
	// OK, ho aperto il file con successo
	// Ora, a seconda del tipo di file, debbo scrivere l'intestazione
	if (FormatNum==1)
	{
		// Salvataggio parametri calcolati
		// copio i parametri nella stringa di testo Clipdata
		AcousticsToClipboard(Clipdata,lpAmp);					
		// Determino quanto  lunga Clipdata
		cp = Clipdata;	// cp punta all'inizio della stringa
		counter=0;
		while (*cp != '\0')
		{
			counter += 1;
			cp += 1;
		}
		counter -=2; // non voglio lo zero finale!

		// Ora scrivo la stringa su file.
		bResult = WriteFile(hResults, Clipdata,  counter, &lpWritten,  NULL);
		strcpy (textbuf,"Acoustic Levels succesfully saved to ");
		strcat (textbuf,IRpath);
		MessageBox(NULL,textbuf,"File Saved",MB_ICONINFORMATION|MB_OK);
	}
	else 
	{	
		if (lpAmp->DispType=='S')
		{
			// Salvataggio del solo buffer Peak & Slow ogni s
			double Xmax=0.0;
			long j;
			
			// inizializzo a zero il progress meter
			ProgressCreate(ci,"Saving Slow Time History every 1s...",NULL);
			ProgressMeter(ci,0,Nstep);

			if (lpAmp->wChannels==1)
			{
				// Mono, salvo solo i buffers del left
				// Intestazione
				strcpy(Clipdata,"Time (s)"); VTAB;
				strcat(Clipdata,"Peak"); VTAB;
				strcat(Clipdata,"Slow"); CRLF;
				counter = strlen(Clipdata);
				// Ora scrivo la stringa su file.
				bResult = WriteFile(hResults, Clipdata,  counter, &lpWritten,  NULL);

				// Inizio il ciclo
				for(i=1000;i<Nstep;i+=1000)       // inizio il ciclo con step 1000 ms, parto da 1 s
				{
					sprintf(Clipdata,"%.6f",CurTime);VTAB;		// Tempo in s

					Xmax=-1000.0;
					fBuf =(float far *)lpAmp->LeftBufPeak;		// puntatore alla Time History Left - Peak
					for(j=0;j<1000;j++) if (fBuf[i-j]>Xmax) Xmax=fBuf[i-j];
					// cosi' Xmax contiene il max Peak del secondo precedente
					sprintf(textbuf,"%.3f",Xmax+lpAmp->LFS);    // SPL Max Peak
					strcat(Clipdata,textbuf);VTAB;

					fBuf =(float far *)lpAmp->LeftBufSlow;		// puntatore alla Time History Left - Slow
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Slow Left
					strcat(Clipdata,textbuf);CRLF;

					counter = strlen(Clipdata);
					// Ora scrivo la stringa su file.
					bResult = WriteFile(hResults, Clipdata,  counter, &lpWritten,  NULL);
					ProgressMeter(ci,i,Nstep);
					if (*ci->lpProgressCanceled) break;
					CurTime+=(Dtau*1000.0);	// preparo il valore del nuovo tempo corrente
				} // fine del ciclo con step 1ms
			}
			else
			{
				// Stereo, salvo entrambi i buffers Slow
				// Intestazione
				strcpy(Clipdata,"Time (ms)"); VTAB;
				strcat(Clipdata,"Peak Left"); VTAB;
				strcat(Clipdata,"Slow Left"); VTAB;
				strcat(Clipdata,"Peak Right"); VTAB;
				strcat(Clipdata,"Slow Right"); CRLF;

				counter = strlen(Clipdata);
				// Ora scrivo la stringa su file.
				bResult = WriteFile(hResults, Clipdata,  counter, &lpWritten,  NULL);

				// Inizio il ciclo
				for(i=999;i<Nstep;i+=1000)       // inizio il ciclo con step 1000 ms, parto da 1 s
				{
					sprintf(Clipdata,"%.6f",CurTime);VTAB; // Tempo in s

					Xmax=-1000.0;
					fBuf =(float far *)lpAmp->LeftBufPeak;		// puntatore alla Time History Left - Peak
					for(j=0;j<1000;j++) if (fBuf[i-j]>Xmax) Xmax=fBuf[i-j];
					// cosi' Xmax contiene il max Peak del secondo precedente
					sprintf(textbuf,"%.3f",Xmax+lpAmp->LFS);    // SPL Max Peak
					strcat(Clipdata,textbuf);VTAB;

					fBuf =(float far *)lpAmp->LeftBufSlow;		// puntatore alla Time History Left - Slow
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Slow Left
					strcat(Clipdata,textbuf);VTAB;

					Xmax=-1000.0;
					fBuf =(float far *)lpAmp->RightBufPeak;		// puntatore alla Time History Right - Peak
					for(j=0;j<1000;j++)	if (fBuf[i-j]>Xmax) Xmax=fBuf[i-j];
					// cosi' Xmax contiene il max Peak del secondo precedente
					sprintf(textbuf,"%.3f",Xmax+lpAmp->LFS);    // SPL Max Peak
					strcat(Clipdata,textbuf);VTAB;

					fBuf =(float far *)lpAmp->RightBufSlow;		// puntatore alla Time History Right - Slow
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Slow Right
					strcat(Clipdata,textbuf);CRLF;

					counter = strlen(Clipdata);
					// Ora scrivo la stringa su file.
					bResult = WriteFile(hResults, Clipdata,  counter, &lpWritten,  NULL);
					ProgressMeter(ci,i,Nstep);
					if (*ci->lpProgressCanceled) break;
					CurTime+=(Dtau*1000.0);	// preparo il valore del nuovo tempo corrente
				} // fine del ciclo con step 1ms
			}
			// distruggo il progress meter, ho finito!
			ProgressDestroy(ci);          
			strcpy (textbuf,"Time History succesfully saved to ");
			strcat (textbuf,IRpath);
			MessageBox(NULL,textbuf,"File Saved",MB_ICONINFORMATION|MB_OK);
		}
		else 
		{
			// Salvataggio dei buffers ogni ms
			
			// inizializzo a zero il progress meter
			ProgressCreate(ci,"Saving Time History...",NULL);
			ProgressMeter(ci,0,Nstep);

			if (lpAmp->wChannels==1)
			{
				// Mono, salvo solo i buffers del left
				// Intestazione
				strcpy(Clipdata,"Time (s)"); VTAB;
				strcat(Clipdata,"Peak (1sample)"); VTAB;
				strcat(Clipdata,"RMS (1ms)"); VTAB;
				strcat(Clipdata,"ITU (30ms)"); VTAB;
				strcat(Clipdata,"Impulse"); VTAB;
				strcat(Clipdata,"Fast"); VTAB;
				strcat(Clipdata,"Slow"); CRLF;
				counter = strlen(Clipdata);
				// Ora scrivo la stringa su file.
				bResult = WriteFile(hResults, Clipdata,  counter, &lpWritten,  NULL);

				// Inizio il ciclo
				for(i=0;i<Nstep;i++)       // inizio il ciclo con step 1ms, parto da 0
				{
					sprintf(Clipdata,"%.6f",CurTime);VTAB;		// Tempo corrente in s
					fBuf =(float far *)lpAmp->LeftBufPeak;		// puntatore alla Time History Left
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo 1ms Left
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->LeftBufInst;		// puntatore alla Time History Left
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo 1ms Left
					strcat(Clipdata,textbuf);VTAB;
					fBuf=(float far *)lpAmp->LeftBuf30ms;		// puntatore alla Time History Left
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo 30ms Left
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->LeftBufImp;		// puntatore alla Time History Left
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Impulse Left
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->LeftBufFast;		// puntatore alla Time History Left
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Fast Left
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->LeftBufSlow;		// puntatore alla Time History Left
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Slow Left
					strcat(Clipdata,textbuf);CRLF;

					counter = strlen(Clipdata);
					// Ora scrivo la stringa su file.
					bResult = WriteFile(hResults, Clipdata,  counter, &lpWritten,  NULL);
					ProgressMeter(ci,i,Nstep);
					if (*ci->lpProgressCanceled) break;
					CurTime+=Dtau;	// preparo il valore del nuovo tempo corrente
				} // fine del ciclo con step 1ms
			}
			else
			{
				// Stereo, salvo entrambi i buffers
				// Intestazione
				strcpy(Clipdata,"Time (s)"); VTAB;
				strcat(Clipdata,"Peak (1sample) Left"); VTAB;
				strcat(Clipdata,"RMS (1ms) Left"); VTAB;
				strcat(Clipdata,"ITU (30ms) Left"); VTAB;
				strcat(Clipdata,"Impulse Left"); VTAB;
				strcat(Clipdata,"Fast Left"); VTAB;
				strcat(Clipdata,"Slow Left"); VTAB;
				strcat(Clipdata,"Peak (1sample) Right"); VTAB;
				strcat(Clipdata,"RMS (1ms) Right"); VTAB;
				strcat(Clipdata,"ITU (30ms) Right"); VTAB;
				strcat(Clipdata,"Impulse Right"); VTAB;
				strcat(Clipdata,"Fast Right"); VTAB;
				strcat(Clipdata,"Slow Right"); CRLF;

				counter = strlen(Clipdata);
				// Ora scrivo la stringa su file.
				bResult = WriteFile(hResults, Clipdata,  counter, &lpWritten,  NULL);

				// Inizio il ciclo
				for(i=0;i<Nstep;i++)       // inizio il ciclo con step 1ms, parto da 0
				{
					sprintf(Clipdata,"%.6f",CurTime);VTAB;		// Tempo in sec
					fBuf =(float far *)lpAmp->LeftBufPeak;		// puntatore alla Time History Left
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Peak Left
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->LeftBufInst;		// puntatore alla Time History Left
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo 1ms Left
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->LeftBuf30ms;		// puntatore alla Time History Left
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo 30ms Left
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->LeftBufImp;		// puntatore alla Time History Left
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Impulse Left
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->LeftBufFast;		// puntatore alla Time History Left
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Fast Left
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->LeftBufSlow;		// puntatore alla Time History Left
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Slow Left
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->RightBufPeak;		// puntatore alla Time History Right
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Peak Right
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->RightBufInst;		// puntatore alla Time History Right
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo 1ms Right
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->RightBuf30ms;		// puntatore alla Time History Right
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo 30ms Right
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->RightBufImp;		// puntatore alla Time History Right
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Impulse Right
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->RightBufFast;		// puntatore alla Time History Right
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Fast Right
					strcat(Clipdata,textbuf);VTAB;
					fBuf =(float far *)lpAmp->RightBufSlow;		// puntatore alla Time History Right
					sprintf(textbuf,"%.3f",fBuf[i]+lpAmp->LFS); // SPL istantaneo Slow Right
					strcat(Clipdata,textbuf);CRLF;

					counter = strlen(Clipdata);
					// Ora scrivo la stringa su file.
					bResult = WriteFile(hResults, Clipdata,  counter, &lpWritten,  NULL);
					ProgressMeter(ci,i,Nstep);
					if (*ci->lpProgressCanceled) break;
					CurTime+=Dtau;	// preparo il valore del nuovo tempo corrente
				} // fine del ciclo con step 1ms

			}
			// distruggo il progress meter, ho finito!
			ProgressDestroy(ci);          
			strcpy (textbuf,"Time History succesfully saved to ");
			strcat (textbuf,IRpath);
			MessageBox(NULL,textbuf,"File Saved",MB_ICONINFORMATION|MB_OK);
		} // Fine dell'if Slow
	}
	CloseHandle (hResults); // Chiudo il file, ho finito il salvataggio

}

__declspec(dllexport) BOOL FAR PASCAL DIALOGMsgProc2(HWND hWndDlg, UINT Message, WPARAM wParam, LPARAM lParam)
{   MLS FAR * lpAmp = NULL;
	HANDLE hTones = NULL;
	COOLINFO far *ci=NULL;
	// char textbuf[40];  
	long nChan;
	
	switch(Message)
   	{	case WM_INITDIALOG:
		{	
			char lin[]="- -";
			
			ci=(COOLINFO far *)lParam;
			hTones=ci->hUserData;         
			lpAmp=(MLS FAR *)GlobalLock(hTones);

			// copio gli indirizzi fondamentali in IDC_STORAGE
			CopyToDlgItem(hWndDlg,IDC_STORAGE,ci,hTones,lpAmp);
			
			// inizializzo e creo la finestra DISPLAY

			lpAmp->hDisplayWnd = DisplayInit(ci,hWndDlg,IDC_RECT,0,DisplayCallback,lpAmp);
			
			// Ora lo imposto per le due serie di dati
			{
				double fLeft=0;
				double fRight=((double)(ci->dwHiSample-ci->dwLoSample))/((double)ci->lSamprate); // lunghezza segnale in sec.
				double fTop;
				double fBottom;

				
				CenterDialog(ci,hWndDlg);
				// mostro i risultati del calcolo
				ShowParameters(hWndDlg,lpAmp);			

				fTop=lpAmp->LFS;
				if (lpAmp->wChannels==2)
					if (lpAmp->RFS > fTop) fTop = lpAmp->RFS;
				fBottom=fTop-100;
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(0,DISPLAY_XLABEL),(DWORD)(LPCSTR)"s");
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(0,DISPLAY_YLABEL),(DWORD)(LPCSTR)"dB");
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(0,DISPLAY_GRIDCOLOR),(DWORD)RGB(196,196,196));
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(0,DISPLAY_BAKCOLOR),(DWORD)RGB(255,255,255));
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(0,DISPLAY_SAMPLERATE),(DWORD)lpAmp->SampRate);
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(0,DISPLAY_TEXTCONTROL),(DWORD)IDC_DISPLAY);
				//serie 1, Left, Blue
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_XLABEL),(DWORD)(LPCSTR)"s");
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_YLABEL),(DWORD)(LPCSTR)"dB");
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_ADDCHART),DISPLAY_MODE_NORMAL);
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_LINECOLOR),(DWORD)BLUE);
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_TOPVALUE),(DWORD)&fTop);
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_BOTTOMVALUE),(DWORD)&fBottom);
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_LEFTVALUE),(DWORD)&fLeft);
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_RIGHTVALUE),(DWORD)&fRight);
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_SAMPLERATE),(DWORD)lpAmp->SampRate);
				SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(1,DISPLAY_TEXTCONTROL),(DWORD)IDC_DISPLAY);
				if (lpAmp->wChannels==2)
				{
					// serie 2, Right, Red
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_XLABEL),(DWORD)(LPCSTR)"s");
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_YLABEL),(DWORD)(LPCSTR)"dB");
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_ADDCHART),DISPLAY_MODE_NORMAL);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_LINECOLOR),(DWORD)RED);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_TOPVALUE),(DWORD)&fTop);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_BOTTOMVALUE),(DWORD)&fBottom);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_LEFTVALUE),(DWORD)&fLeft);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_RIGHTVALUE),(DWORD)&fRight);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_SAMPLERATE),(DWORD)lpAmp->SampRate);
					SendMessage(lpAmp->hDisplayWnd,WM_SETDISPLAYDATA,MAKELONG(2,DISPLAY_TEXTCONTROL),(DWORD)IDC_DISPLAY);
				}
				EnableWindow(lpAmp->hDisplayWnd,TRUE);
			}
   

	 		// using scripts, auto OK it.
	 		if ((ci->iScriptFile!=-1) && (!ci->iScriptDialogStop))
		 		PostMessage(hWndDlg,WM_COMMAND,IDOK,0L);
	
		}    		
        break; /* End of WM_INITDIALOG                                 */

    case WM_CLOSE:
         /* Closing the Dialog behaves the same as CANCEL              */
         PostMessage(hWndDlg, WM_COMMAND, IDCANCEL, 0L);
         break; 

	case WM_COMMAND:
         // copio gli indirizzi fondamentali da IDC_STORAGE
         CopyFromDlgItem(hWndDlg,IDC_STORAGE,&ci,&hTones,&lpAmp); 
		 
		 // inizializzo alcuni parametri	
		 nChan=lpAmp->wChannels;
	     switch(LOWORD(wParam))
           {  

			case IDC_PEAK:     
				lpAmp->DispType='P';
				UpdateDisplay(lpAmp->hDisplayWnd);
				break;

			case IDC_INST:     
				lpAmp->DispType='1';
				UpdateDisplay(lpAmp->hDisplayWnd);
				break;
		 
			case IDC_30MS:     
				lpAmp->DispType='3';
				UpdateDisplay(lpAmp->hDisplayWnd);
				break;
		 
			case IDC_FAST:     
				lpAmp->DispType='F';
				UpdateDisplay(lpAmp->hDisplayWnd);
				break;

			case IDC_SLOW:     
				lpAmp->DispType='S';
				UpdateDisplay(lpAmp->hDisplayWnd);
				break;
		 
			case IDC_IMP:     
				lpAmp->DispType='I';
				UpdateDisplay(lpAmp->hDisplayWnd);
				break;

			case IDC_AVG:     
				if (IsDlgButtonChecked(hWndDlg,IDC_AVG)) lpAmp->Avg=TRUE; else lpAmp->Avg=FALSE ; 
				ShowParameters(hWndDlg,lpAmp);			
				break;


			case ID_HLP:
           		 WinHelp(hWndDlg,XFM_HELPFILE,HELP_KEY,(DWORD)((LPSTR)"ITU P56 Active Speech Level"));
                 break;  


			case IDC_CLIPBOARD:     
			{
				HANDLE hClipdata;
				char *Clipdata;
				char ok=TRUE;

				// alloco memoria
				if (hClipdata=GlobalAlloc(GMEM_MOVEABLE|GMEM_SHARE,2000*ci->wChannels))
				{	
					if (!(Clipdata=(char *)GlobalLock(hClipdata)))
					{
						GlobalFree(hClipdata);
						ok=FALSE;
					}	                               
		        }
		        else ok=FALSE;
		    
			    // se l'allocazione  riuscita 
			    // memorizzo i parametri nella clipboard
				if (ok)
				{                          
					// copio i parametri nella Clipboard
	                AcousticsToClipboard(Clipdata,lpAmp);					
					
					// unlocko hClipdata	
					GlobalUnlock(hClipdata);
				    // copio nella clipboard
				    if (OpenClipboard(lpAmp->hWnd))
				    {                                               
				    	EmptyClipboard(); 
				    	SetClipboardData(CF_TEXT,hClipdata);
				        if (!(CloseClipboard())) ok=0;
				    }    
				    else ok=0;
				    // se non sono riuscito a scrivere nella clipboard 
				    // mando un messaggio e libero hClipdata
				    if (!(ok))
			    	{   
				    	// mando un suono di stop
				    	// MessageBeep(MB_ICONHAND);
						MessageBox(lpAmp->hWnd,"Can not access Clipboard Data.\nAnother application or window\nhas the Clipboard opened.","ITU-T P.56",MB_ICONSTOP|MB_OK);
				  		GlobalFree(hClipdata);
				  	}	
					MessageBeep(MB_OK);
				}
			}
			break;	
          	case IDOK:
                 GlobalUnlock(hTones); 
             	 hTones=NULL;
                 EndDialog(hWndDlg,TRUE);	
               	 break;                                                    
          	case IDCANCEL:
                 GlobalUnlock(hTones); 
             	 hTones=NULL;
                 EndDialog(hWndDlg,FALSE);	
               	 break;                                                    
			case IDC_SAVEPAR:
			  	 SaveParams(ci,lpAmp);
			break;
           }
         break;    // End of WM_COMMAND                                 */

    default:
		return FALSE;
   }
 	return TRUE;
}   

