/************************************************/
/*                Strength.h                    */
/************************************************/

// Use an Internal Structure for your function, and access it through a handle
#pragma pack(1)
typedef struct mls_tag
{   
	HWND hWnd;
	HINSTANCE hInst;	
	HANDLE hDlg;
	HANDLE hDisplayWnd;
	char FiltType;  //Tipo di filtraggio: L=lineare (nessun filtro), B=BandPass (ITU), A=A-weighting
	char FiltType2;  //Tipo di filtraggio: L=lineare (nessun filtro), B=BandPass (ITU), A=A-weighting
	float LFS;       //Livello FullScale per calibrazione (Left o Mono)
	float RFS;       //Livello FullScale per calibrazione (Right)
	float LCal;      //Livello Leq per calibrazione (Left o Mono)
	float RCal;      //Livello Leq per calibrazione (Right)
	char CALtype;   //tipo di calibrazione (F=FullScale o L=Leq)
	char DispType;  //curva da visualizzare (Peak, 1ms, Fast, Slow, Impulse)
	long SampRate;  //frequenza di campionamento
	long N;         //numero di campioni
	long wChannels; //numero di canali
	long LeftBufPeak;   //buffer Time History Left(Mono)
	long LeftBufInst;   //buffer Time History Left(Mono)
	long LeftBuf30ms;   //buffer Time History Left(Mono)
	long LeftBufFast;   //buffer Time History Left(Mono)
	long LeftBufSlow;   //buffer Time History Left(Mono)
	long LeftBufImp;    //buffer Time History Left(Mono)
	long RightBufPeak;  //buffer Time History Right             	
	long RightBufInst;  //buffer Time History Right             	
	long RightBuf30ms;  //buffer Time History Right             	
	long RightBufFast;  //buffer Time History Right             	
	long RightBufSlow;  //buffer Time History Right             	
	long RightBufImp;   //buffer Time History Right             	
	// risultati del calcolo
	float LLeq;
	float LASL;
	float LTHR;
	float LAR;
	float LBACK;
	float LSNR;
    float LMax1ms;
    float LMaxPeak;
	float LMaxImp;
	float LMaxFast;
	float LMaxSlow;
	float LDur;
	BOOL  LImpFlag;
	float RLeq;
	float RASL;
	float RTHR;
	float RAR;
	float RBACK;
	float RSNR;
    float RMax1ms;
    float RMaxPeak;
	float RMaxImp;
	float RMaxFast;
	float RMaxSlow;
	float RDur;
	BOOL  RImpFlag;
	BOOL  Avg;
	BOOL  RemoveDC;
	// Registrazione del modulo
	char  username[256];
    char  regkey[256];
	char LastIRDir[256];
	char cName[256];
	char IRFilePath[256];
} MLS;
#pragma pack()

// Structure Definition for Preset and Script handling
// Structure Preset Vars: 'y' to include in presets, 'n' to ignore.

#define STRUCTDEFINITION "hhhhccffffcclllllllllllllllffffffffffffbffffffffffffbbbccccc"
#define PRESETDEFINITION "yyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy"
// Structure Definition for Preset and Script handling
// list variable types as:  c char
//							b BOOL
//							i short or WORD 
//							f float
//							l long or DWORD
//							d double
//							g GRAPH
//							h Global Handle  
//							s String of 256 chars
//

#define TRANSFORMNAME "Aurora\\ITUP56 Time History Analysis"

#define CRLFDEF char crlf[]={0x0d,0x0a,0}
#define CRLF strcat(Clipdata,crlf)
#define VTABDEF char vtab[]={0x09,0}
#define VTAB strcat(Clipdata,vtab)

//*******************************************************************************
//		DEFINISCO LE COSTANTI CHE SERVONO AD ORIENTARE LE FRECCE NEL DISPLAY
//*******************************************************************************
#define HORIZONTAL			0
#define VERTICAL			1

//*******************************************************************************
//		DEFINISCO ALCUNI COLORI
//*******************************************************************************
#define WHITE				RGB(255, 255, 255)
#define BLACK				RGB(0, 0, 0)
#define RED					RGB(255, 0, 0)
#define GREEN				RGB(0, 255, 0)
#define BLUE				RGB(0, 0, 255)
#define YELLOW				RGB(255, 255, 0)
#define DARKGRAY			RGB(128, 128, 128)
#define DARKBLUE			RGB(0, 0, 128)
#define CYAN				RGB(0, 255, 255)
#define VIOLET				RGB(128, 0, 128)
